local YurrCombatLog = LibStub("AceAddon-3.0"):GetAddon("YurrCombatLog")
local L = LibStub("AceLocale-3.0"):GetLocale("YurrCombatLog")
local options

local CombatLog_Object_IsA = CombatLog_Object_IsA

local defaults = {
	profile = {
		
		
		ChatFrame = 2,
		timestamp = true,
		timestampFormat = "[%H:%M:%S]",
		QuickButtonFrameHide = true,
		
		-- Taken from Blizzard_CombatLog
		amountColoring = true,
		unitColoring = true,
		sourceColoring = true,
		destColoring = true,
		actionColoring = true,
		missColoring = true,
		actionSchoolColoring = true,
		actionHighlighting = true,
		abilityColoring = true,
		abilitySchoolColoring = true,
		amountSchoolColoring = true,
		noMeleeSwingColoring = true,
		actionAuraEventColoring = true,
		auraEventColoring = true,
		braces = true,
		unitBraces = true,
		sourceBraces = true,
		destBraces = true,
		spellBraces = false,
		itemBraces = true,
		
		allSource = {
			Player = true,
		},
		allDestination = {
			Player = true,
		},
		
		filters = {
			[1] = {
				-- Descriptive Information
				name = "Player",
				-- The actual client filters
				filters = {
					[1] = {
						eventList = {
							["ENVIRONMENTAL_DAMAGE"] = true,
							["SWING_DAMAGE"] = true,
							["SWING_MISSED"] = true,
							["RANGE_DAMAGE"] = true,
							["RANGE_MISSED"] = true,
							["SPELL_CAST_START"] = false,
							--["SPELL_CAST_SUCCESS"] = true,
							["SPELL_CAST_FAILED"] = false,
							["SPELL_MISSED"] = true,
							["SPELL_DAMAGE"] = true,
							["SPELL_HEAL"] = true,
							["SPELL_ENERGIZE"] = true,
							["SPELL_DRAIN"] = true,
							["SPELL_LEECH"] = true,
							["SPELL_INSTAKILL"] = true,
							["SPELL_INTERRUPT"] = true,
							["SPELL_EXTRA_ATTACKS"] = true,
							["SPELL_DURABILITY_DAMAGE"] = true,
							["SPELL_DURABILITY_DAMAGE_ALL"] = true,
							["SPELL_AURA_APPLIED"] = true,
							["SPELL_AURA_APPLIED_DOSE"] = true,
							["SPELL_AURA_REMOVED"] = true,
							["SPELL_AURA_REMOVED_DOSE"] = true,
							["SPELL_AURA_BROKEN"] = true,
							["SPELL_AURA_BROKEN_SPELL"] = true,
							["SPELL_AURA_REFRESH"] = true,
							["SPELL_DISPEL"] = true,
							["SPELL_STOLEN"] = true,
							["ENCHANT_APPLIED"] = true,
							["ENCHANT_REMOVED"] = true,
							["SPELL_PERIODIC_MISSED"] = true,
							["SPELL_PERIODIC_DAMAGE"] = true,
							["SPELL_PERIODIC_HEAL"] = true,
							["SPELL_PERIODIC_ENERGIZE"] = true,
							["SPELL_PERIODIC_DRAIN"] = true,
							["SPELL_PERIODIC_LEECH"] = true,
							["SPELL_DISPEL_FAILED"] = true,
							["DAMAGE_SHIELD"] = true,
							["DAMAGE_SHIELD_MISSED"] = true,
							["DAMAGE_SPLIT"] = true,
							["PARTY_KILL"] = true,
							["UNIT_DIED"] = true,
							["UNIT_DESTROYED"] = true
						},
						sourceFlags = {
							[1297] = true,
							--[COMBATLOG_FILTER_MY_PET] = true
						},
						destFlags = nil,
						flagOptions = {
							[1] = true,
							[16] = true,
							[256] = true,
							[1024] = true,
						},
					},
					[2] = {
						eventList = {
							--["ENVIRONMENTAL_DAMAGE"] = true,
							["SWING_DAMAGE"] = true,
							["SWING_MISSED"] = true,
							["RANGE_DAMAGE"] = true,
							["RANGE_MISSED"] = true,
							["SPELL_CAST_START"] = false,
							--["SPELL_CAST_SUCCESS"] = true,
							["SPELL_CAST_FAILED"] = false,
							["SPELL_MISSED"] = true,
							["SPELL_DAMAGE"] = true,
							["SPELL_HEAL"] = true,
							["SPELL_ENERGIZE"] = true,
							["SPELL_DRAIN"] = true,
							["SPELL_LEECH"] = true,
							["SPELL_INSTAKILL"] = true,
							["SPELL_INTERRUPT"] = true,
							["SPELL_EXTRA_ATTACKS"] = true,
							["SPELL_DURABILITY_DAMAGE"] = true,
							["SPELL_DURABILITY_DAMAGE_ALL"] = true,
							--["SPELL_AURA_APPLIED"] = true,
							--["SPELL_AURA_APPLIED_DOSE"] = true,
							--["SPELL_AURA_REMOVED"] = true,
							--["SPELL_AURA_REMOVED_DOSE"] = true,
							["SPELL_DISPEL"] = true,
							["SPELL_STOLEN"] = true,
							["ENCHANT_APPLIED"] = true,
							["ENCHANT_REMOVED"] = true,
							--["SPELL_PERIODIC_MISSED"] = true,
							--["SPELL_PERIODIC_DAMAGE"] = true,
							--["SPELL_PERIODIC_HEAL"] = true,
							--["SPELL_PERIODIC_ENERGIZE"] = true,
							--["SPELL_PERIODIC_DRAIN"] = true,
							--["SPELL_PERIODIC_LEECH"] = true,
							["SPELL_DISPEL_FAILED"] = true,
							--["DAMAGE_SHIELD"] = true,
							--["DAMAGE_SHIELD_MISSED"] = true,
							["DAMAGE_SPLIT"] = true,
							["PARTY_KILL"] = true,
							["UNIT_DIED"] = true,
							["UNIT_DESTROYED"] = true,
						},
						sourceFlags = nil,
						destFlags = {
							[1297] = true,
							--[COMBATLOG_FILTER_MY_PET] = true,
						},
						flagOptions = {
							[1] = true,
							[16] = true,
							[256] = true,
							[1024] = true,
						},
					},
				},
			},
			[2] = {
				["name"] = "Outsider",
				["filters"] = {
					{
						["eventList"] = {
							["SPELL_PERIODIC_MISSED"] = true,
							["SPELL_INTERRUPT"] = true,
							["UNIT_DESTROYED"] = true,
							["DAMAGE_SHIELD_MISSED"] = true,
							["SPELL_LEECH"] = true,
							["SPELL_AURA_BROKEN"] = true,
							["UNIT_DIED"] = true,
							["SPELL_PERIODIC_ENERGIZE"] = true,
							["SPELL_INSTAKILL"] = true,
							["SPELL_PERIODIC_DAMAGE"] = true,
							["SPELL_PERIODIC_HEAL"] = true,
							["PARTY_KILL"] = true,
							["SPELL_DAMAGE"] = true,
							["RANGE_DAMAGE"] = true,
							["ENVIRONMENTAL_DAMAGE"] = true,
							["SPELL_DISPEL"] = true,
							["SPELL_EXTRA_ATTACKS"] = true,
							["SPELL_MISSED"] = true,
							["SPELL_STOLEN"] = true,
							["SPELL_ENERGIZE"] = true,
							["SWING_MISSED"] = true,
							["SPELL_AURA_REFRESH"] = true,
							["DAMAGE_SHIELD"] = true,
							["SPELL_AURA_REMOVED_DOSE"] = true,
							["SPELL_PERIODIC_LEECH"] = true,
							["SPELL_DISPEL_FAILED"] = true,
							["SPELL_AURA_APPLIED_DOSE"] = true,
							["SPELL_AURA_REMOVED"] = true,
							["SWING_DAMAGE"] = true,
							["SPELL_AURA_BROKEN_SPELL"] = true,
							["ENCHANT_APPLIED"] = true,
							["RANGE_MISSED"] = true,
							["SPELL_HEAL"] = true,
							["ENCHANT_REMOVED"] = true,
							["SPELL_AURA_APPLIED"] = true,
							["SPELL_PERIODIC_DRAIN"] = true,
							["SPELL_DRAIN"] = true,
						},
						["sourceFlags"] = {
							[1304] = false,
						},
						["flagOptions"] = {
							false, -- [1]
							[256] = true,
							[8] = true,
							[1024] = true,
							[16] = true,
						},
					}, -- [1]
					{
						["eventList"] = {
							["SPELL_EXTRA_ATTACKS"] = true,
							["SPELL_MISSED"] = true,
							["SPELL_STOLEN"] = true,
							["SPELL_ENERGIZE"] = true,
							["SPELL_INTERRUPT"] = true,
							["SWING_MISSED"] = true,
							["SPELL_LEECH"] = true,
							["UNIT_DIED"] = true,
							["ENCHANT_APPLIED"] = true,
							["SPELL_DISPEL_FAILED"] = true,
							["SPELL_INSTAKILL"] = true,
							["UNIT_DESTROYED"] = true,
							["SWING_DAMAGE"] = true,
							["PARTY_KILL"] = true,
							["SPELL_DAMAGE"] = true,
							["RANGE_MISSED"] = true,
							["RANGE_DAMAGE"] = true,
							["ENCHANT_REMOVED"] = true,
							["SPELL_HEAL"] = true,
							["SPELL_DISPEL"] = true,
							["SPELL_DRAIN"] = true,
						},
						["destFlags"] = {
							[1304] = false,
						},
						["flagOptions"] = {
							false, -- [1]
							[256] = true,
							[8] = true,
							[1024] = true,
							[16] = true,
						},
					}, -- [2]
				},
			}, -- [2]
			[3] = {
				["name"] = "Raid",
				["filters"] = {
					{
						["flagOptions"] = {
							false, -- [1]
							[256] = true,
							[4] = true,
							[1024] = true,
							[16] = true,
						},
						["sourceFlags"] = {
							[1300] = false,
						},
						["eventList"] = {
							["SPELL_PERIODIC_MISSED"] = true,
							["SPELL_INTERRUPT"] = true,
							["UNIT_DESTROYED"] = true,
							["DAMAGE_SHIELD_MISSED"] = true,
							["SPELL_LEECH"] = true,
							["SPELL_AURA_BROKEN"] = true,
							["UNIT_DIED"] = true,
							["SPELL_PERIODIC_ENERGIZE"] = true,
							["SPELL_INSTAKILL"] = true,
							["SPELL_PERIODIC_DAMAGE"] = true,
							["SPELL_PERIODIC_HEAL"] = true,
							["PARTY_KILL"] = true,
							["SPELL_DAMAGE"] = true,
							["RANGE_DAMAGE"] = true,
							["ENVIRONMENTAL_DAMAGE"] = true,
							["SPELL_DISPEL"] = true,
							["SPELL_EXTRA_ATTACKS"] = true,
							["SPELL_MISSED"] = true,
							["SPELL_STOLEN"] = true,
							["SPELL_ENERGIZE"] = true,
							["SWING_MISSED"] = true,
							["SPELL_AURA_REFRESH"] = true,
							["DAMAGE_SHIELD"] = true,
							["SPELL_AURA_REMOVED_DOSE"] = true,
							["SPELL_PERIODIC_LEECH"] = true,
							["SPELL_DISPEL_FAILED"] = true,
							["SPELL_AURA_APPLIED"] = true,
							["ENCHANT_REMOVED"] = true,
							["SWING_DAMAGE"] = true,
							["SPELL_AURA_BROKEN_SPELL"] = true,
							["ENCHANT_APPLIED"] = true,
							["RANGE_MISSED"] = true,
							["SPELL_HEAL"] = true,
							["SPELL_AURA_REMOVED"] = true,
							["SPELL_AURA_APPLIED_DOSE"] = true,
							["SPELL_PERIODIC_DRAIN"] = true,
							["SPELL_DRAIN"] = true,
						},
					}, -- [1]
					{
						["flagOptions"] = {
							false, -- [1]
							[256] = true,
							[4] = true,
							[1024] = true,
							[16] = true,
						},
						["destFlags"] = {
							[1300] = false,
						},
						["eventList"] = {
							["SPELL_EXTRA_ATTACKS"] = true,
							["SPELL_MISSED"] = true,
							["SPELL_STOLEN"] = true,
							["SPELL_ENERGIZE"] = true,
							["SPELL_INTERRUPT"] = true,
							["SWING_MISSED"] = true,
							["SPELL_LEECH"] = true,
							["UNIT_DIED"] = true,
							["ENCHANT_APPLIED"] = true,
							["SPELL_DISPEL_FAILED"] = true,
							["SPELL_INSTAKILL"] = true,
							["UNIT_DESTROYED"] = true,
							["SWING_DAMAGE"] = true,
							["PARTY_KILL"] = true,
							["SPELL_DAMAGE"] = true,
							["RANGE_MISSED"] = true,
							["RANGE_DAMAGE"] = true,
							["ENCHANT_REMOVED"] = true,
							["SPELL_HEAL"] = true,
							["SPELL_DISPEL"] = true,
							["SPELL_DRAIN"] = true,
						},
					}, -- [2]
				},
			}, -- [3]
			[4] = {
				["name"] = "Pet",
				["filters"] = {
					{
						["flagOptions"] = {
							true, -- [1]
							[256] = true,
							[4096] = true,
							[1024] = false,
							[16] = true,
						},
						["sourceFlags"] = {
							[4369] = false,
						},
						["eventList"] = {
							["SPELL_PERIODIC_MISSED"] = true,
							["SPELL_INTERRUPT"] = true,
							["UNIT_DESTROYED"] = true,
							["DAMAGE_SHIELD_MISSED"] = true,
							["SPELL_LEECH"] = true,
							["SPELL_AURA_BROKEN"] = true,
							["UNIT_DIED"] = true,
							["SPELL_PERIODIC_ENERGIZE"] = true,
							["SPELL_INSTAKILL"] = true,
							["SPELL_PERIODIC_DAMAGE"] = true,
							["SPELL_PERIODIC_HEAL"] = true,
							["PARTY_KILL"] = true,
							["SPELL_DAMAGE"] = true,
							["RANGE_DAMAGE"] = true,
							["ENVIRONMENTAL_DAMAGE"] = true,
							["SPELL_DISPEL"] = true,
							["SPELL_EXTRA_ATTACKS"] = true,
							["SPELL_MISSED"] = true,
							["SPELL_STOLEN"] = true,
							["SPELL_ENERGIZE"] = true,
							["SWING_MISSED"] = true,
							["SPELL_AURA_REFRESH"] = true,
							["DAMAGE_SHIELD"] = true,
							["SPELL_AURA_REMOVED_DOSE"] = true,
							["SPELL_PERIODIC_LEECH"] = true,
							["SPELL_DISPEL_FAILED"] = true,
							["SPELL_AURA_APPLIED"] = true,
							["ENCHANT_REMOVED"] = true,
							["SWING_DAMAGE"] = true,
							["SPELL_AURA_BROKEN_SPELL"] = true,
							["ENCHANT_APPLIED"] = true,
							["RANGE_MISSED"] = true,
							["SPELL_HEAL"] = true,
							["SPELL_AURA_REMOVED"] = true,
							["SPELL_AURA_APPLIED_DOSE"] = true,
							["SPELL_PERIODIC_DRAIN"] = true,
							["SPELL_DRAIN"] = true,
						},
					}, -- [1]
					{
						["flagOptions"] = {
							true, -- [1]
							[256] = true,
							[4096] = true,
							[1024] = false,
							[16] = true,
						},
						["destFlags"] = {
							[4369] = false,
						},
						["eventList"] = {
							["SPELL_EXTRA_ATTACKS"] = true,
							["SPELL_MISSED"] = true,
							["SPELL_STOLEN"] = true,
							["SPELL_ENERGIZE"] = true,
							["SPELL_INTERRUPT"] = true,
							["SWING_MISSED"] = true,
							["SPELL_LEECH"] = true,
							["UNIT_DIED"] = true,
							["ENCHANT_APPLIED"] = true,
							["SPELL_DISPEL_FAILED"] = true,
							["SPELL_INSTAKILL"] = true,
							["UNIT_DESTROYED"] = true,
							["SWING_DAMAGE"] = true,
							["PARTY_KILL"] = true,
							["SPELL_DAMAGE"] = true,
							["RANGE_MISSED"] = true,
							["RANGE_DAMAGE"] = true,
							["ENCHANT_REMOVED"] = true,
							["SPELL_HEAL"] = true,
							["SPELL_DISPEL"] = true,
							["SPELL_DRAIN"] = true,
						},
					}, -- [2]
				},
			}, -- [4]
			[5] = {
				["name"] = "Party",
				["filters"] = {
					{
						["flagOptions"] = {
							false, -- [1]
							true, -- [2]
							nil, -- [3]
							false, -- [4]
							[256] = true,
							[16] = true,
							[1024] = true,
						},
						["sourceFlags"] = {
							[1298] = false,
						},
						["eventList"] = {
							["SPELL_PERIODIC_MISSED"] = true,
							["SPELL_INTERRUPT"] = true,
							["UNIT_DESTROYED"] = true,
							["DAMAGE_SHIELD_MISSED"] = true,
							["SPELL_LEECH"] = true,
							["SPELL_AURA_BROKEN"] = true,
							["UNIT_DIED"] = true,
							["SPELL_PERIODIC_ENERGIZE"] = true,
							["SPELL_INSTAKILL"] = true,
							["SPELL_PERIODIC_DAMAGE"] = true,
							["SPELL_PERIODIC_HEAL"] = true,
							["PARTY_KILL"] = true,
							["SPELL_DAMAGE"] = true,
							["RANGE_DAMAGE"] = true,
							["ENVIRONMENTAL_DAMAGE"] = true,
							["SPELL_DISPEL"] = true,
							["SPELL_EXTRA_ATTACKS"] = true,
							["SPELL_MISSED"] = true,
							["SPELL_STOLEN"] = true,
							["SPELL_ENERGIZE"] = true,
							["SWING_MISSED"] = true,
							["SPELL_AURA_REFRESH"] = true,
							["DAMAGE_SHIELD"] = true,
							["SPELL_AURA_REMOVED_DOSE"] = true,
							["SPELL_PERIODIC_LEECH"] = true,
							["SPELL_DISPEL_FAILED"] = true,
							["SPELL_AURA_APPLIED"] = true,
							["ENCHANT_REMOVED"] = true,
							["SWING_DAMAGE"] = true,
							["SPELL_AURA_BROKEN_SPELL"] = true,
							["ENCHANT_APPLIED"] = true,
							["RANGE_MISSED"] = true,
							["SPELL_HEAL"] = true,
							["SPELL_AURA_REMOVED"] = true,
							["SPELL_AURA_APPLIED_DOSE"] = true,
							["SPELL_PERIODIC_DRAIN"] = true,
							["SPELL_DRAIN"] = true,
						},
					}, -- [1]
					{
						["flagOptions"] = {
							false, -- [1]
							true, -- [2]
							[256] = true,
							[1024] = true,
							[16] = true,
						},
						["destFlags"] = {
							[1298] = false,
						},
						["eventList"] = {
							["SPELL_EXTRA_ATTACKS"] = true,
							["SPELL_MISSED"] = true,
							["SPELL_STOLEN"] = true,
							["SPELL_ENERGIZE"] = true,
							["SPELL_INTERRUPT"] = true,
							["SWING_MISSED"] = true,
							["SPELL_LEECH"] = true,
							["UNIT_DIED"] = true,
							["ENCHANT_APPLIED"] = true,
							["SPELL_DISPEL_FAILED"] = true,
							["SPELL_INSTAKILL"] = true,
							["UNIT_DESTROYED"] = true,
							["SWING_DAMAGE"] = true,
							["PARTY_KILL"] = true,
							["SPELL_DAMAGE"] = true,
							["RANGE_MISSED"] = true,
							["RANGE_DAMAGE"] = true,
							["ENCHANT_REMOVED"] = true,
							["SPELL_HEAL"] = true,
							["SPELL_DISPEL"] = true,
							["SPELL_DRAIN"] = true,
						},
					}, -- [2]
				},
			}, -- [5]
			[6] = {
				["name"] = "Enemy",
				["filters"] = {
					{
						["flagOptions"] = {
							false, -- [1]
							[32] = true,
							[1024] = true,
							[512] = true,
							[16384] = true,
							[8] = true,
							[8192] = true,
							[2048] = true,
							[256] = true,
							[64] = true,
							[4096] = true,
							[16] = false,
						},
						["sourceFlags"] = {
							[32616] = false,
						},
						["eventList"] = {
							["SPELL_PERIODIC_MISSED"] = true,
							["SPELL_INTERRUPT"] = true,
							["UNIT_DESTROYED"] = true,
							["DAMAGE_SHIELD_MISSED"] = true,
							["SPELL_LEECH"] = true,
							["SPELL_AURA_BROKEN"] = true,
							["UNIT_DIED"] = true,
							["SPELL_PERIODIC_ENERGIZE"] = true,
							["SPELL_INSTAKILL"] = true,
							["SPELL_PERIODIC_DAMAGE"] = true,
							["SPELL_PERIODIC_HEAL"] = true,
							["PARTY_KILL"] = true,
							["SPELL_DAMAGE"] = true,
							["RANGE_DAMAGE"] = true,
							["ENVIRONMENTAL_DAMAGE"] = true,
							["SPELL_DISPEL"] = true,
							["SPELL_EXTRA_ATTACKS"] = true,
							["SPELL_MISSED"] = true,
							["SPELL_STOLEN"] = true,
							["SPELL_ENERGIZE"] = true,
							["SWING_MISSED"] = true,
							["SPELL_AURA_REFRESH"] = true,
							["DAMAGE_SHIELD"] = true,
							["SPELL_AURA_REMOVED_DOSE"] = true,
							["SPELL_PERIODIC_LEECH"] = true,
							["SPELL_DISPEL_FAILED"] = true,
							["SPELL_AURA_APPLIED"] = true,
							["ENCHANT_REMOVED"] = true,
							["SWING_DAMAGE"] = true,
							["SPELL_AURA_BROKEN_SPELL"] = true,
							["ENCHANT_APPLIED"] = true,
							["RANGE_MISSED"] = true,
							["SPELL_HEAL"] = true,
							["SPELL_AURA_REMOVED"] = true,
							["SPELL_AURA_APPLIED_DOSE"] = true,
							["SPELL_PERIODIC_DRAIN"] = true,
							["SPELL_DRAIN"] = true,
						},
					}, -- [1]
					{
						["flagOptions"] = {
							false, -- [1]
							[32] = true,
							[1024] = true,
							[512] = true,
							[16384] = true,
							[8] = true,
							[8192] = true,
							[4096] = true,
							[256] = true,
							[64] = true,
							[2048] = true,
							[16] = false,
						},
						["destFlags"] = {
							[32616] = false,
						},
						["eventList"] = {
							["SPELL_EXTRA_ATTACKS"] = true,
							["SPELL_MISSED"] = true,
							["SPELL_STOLEN"] = true,
							["SPELL_ENERGIZE"] = true,
							["SPELL_INTERRUPT"] = true,
							["SWING_MISSED"] = true,
							["SPELL_LEECH"] = true,
							["UNIT_DIED"] = true,
							["ENCHANT_APPLIED"] = true,
							["SPELL_DISPEL_FAILED"] = true,
							["SPELL_INSTAKILL"] = true,
							["UNIT_DESTROYED"] = true,
							["SWING_DAMAGE"] = true,
							["PARTY_KILL"] = true,
							["SPELL_DAMAGE"] = true,
							["RANGE_MISSED"] = true,
							["RANGE_DAMAGE"] = true,
							["ENCHANT_REMOVED"] = true,
							["SPELL_HEAL"] = true,
							["SPELL_DISPEL"] = true,
							["SPELL_DRAIN"] = true,
						},
					}, -- [2]
				},
			}, -- [6]
		},
		
		enabledFilters = {
		},
		
		flags = {
			sourceFlags = {
				Player = {

				},
				Outsider = {
					["256"] = "256",
					["64"] = "64",
					["4096"] = "4096",
					["1024"] = "1024",
					["8"] = "8",
					["512"] = "512",
					["8192"] = "8192",
					["16"] = "16",
					["2048"] = "2048",
					["16384"] = "16384",
					["32"] = "32",
				},
				Guardian = {
					["1"] = "1",
					["16"] = "16",
					["8192"] = "8192",
					["64"] = "64",
					["256"] = "256",
					["32"] = "32",
				},
				Focus = {
					["131072"] = "131072",
				},
				Target = {
					["65536"] = "65536",
				},
				Raid = {
					["1024"] = "1024",
					["16"] = "16",
					["256"] = "256",
					["4"] = "4",
					["64"] = "64",
					["32"] = "32",
				},
				Pet = {
					["1"] = "1",
					["4096"] = "4096",
					["16"] = "16",
					["64"] = "64",
					["256"] = "256",
					["32"] = "32",
				},
				Party = {
					["1024"] = "1024",
					["16"] = "16",
					["2"] = "2",
					["64"] = "64",
					["256"] = "256",
					["32"] = "32",
				},
				
			},
			destFlags = {
				Player = {
					["1"] = "1",
					["16"] = "16",
					["256"] = "256",
					["1024"] = "1024",
				},
				Outsider = {
					["256"] = "256",
					["64"] = "64",
					["16"] = "16",
					["1024"] = "1024",
					["8"] = "8",
					["512"] = "512",
					["8192"] = "8192",
					["4096"] = "4096",
					["2048"] = "2048",
					["16384"] = "16384",
					["32"] = "32",
				},
				Guardian = {
					["1"] = "1",
					["16"] = "16",
					["8192"] = "8192",
					["64"] = "64",
					["256"] = "256",
					["32"] = "32",
				},
				Focus = {
					["131072"] = "131072",
				},
				Target = {
					["65536"] = "65536",
				},
				Raid = {
					["1024"] = "1024",
					["16"] = "16",
					["256"] = "256",
					["4"] = "4",
					["64"] = "64",
					["32"] = "32",
				},
				Pet = {
					["1"] = "1",
					["4096"] = "4096",
					["16"] = "16",
					["64"] = "64",
					["256"] = "256",
					["32"] = "32",
				},
				Party = {
					["1024"] = "1024",
					["16"] = "16",
					["2"] = "2",
					["64"] = "64",
					["256"] = "256",
					["32"] = "32",
				},
			},
		},
		
		misc = {
			experience = true,
			faction = true,
			skill = true,
			honor = true,
		},
		
		watches = {
		},
		
		format = {
			DAMAGE_SHIELD = "",
			DAMAGE_SHIELD_MISSED = "",
			DAMAGE_SHIELD_MISSED_BLOCK = "",
			DAMAGE_SHIELD_MISSED_DEFLECT = "",
			DAMAGE_SHIELD_MISSED_DODGE = "",
			DAMAGE_SHIELD_MISSED_EVADED = "",
			DAMAGE_SHIELD_MISSED_IMMUNE = "",
			DAMAGE_SHIELD_MISSED_MISS = "",
			DAMAGE_SHIELD_MISSED_PARRY = "",
			DAMAGE_SHIELD_MISSED_RESIST = "",
			DAMAGE_SHIELD_MISSED_REFLECT = "",
			DAMAGE_SPLIT = ACTION_DAMAGE_SPLIT,
			ENCHANT_APPLIED = "++",
			ENCHANT_REMOVED = "--",
			ENVIRONMENTAL_DAMAGE = "",
			ENVIRONMENTAL_DAMAGE_DROWNING = L["Drown"],
			ENVIRONMENTAL_DAMAGE_FALLING = L["Fall"],
			ENVIRONMENTAL_DAMAGE_FATIGUE = ACTION_ENVIRONMENTAL_DAMAGE_FATIGUE,
			ENVIRONMENTAL_DAMAGE_FIRE = ACTION_ENVIRONMENTAL_DAMAGE_FIRE,
			ENVIRONMENTAL_DAMAGE_LAVA = ACTION_ENVIRONMENTAL_DAMAGE_LAVA,
			ENVIRONMENTAL_DAMAGE_SLIME = ACTION_ENVIRONMENTAL_DAMAGE_SLIME,
			PARTY_KILL = ACTION_PARTY_KILL,
			RANGED = "",
			RANGE_DAMAGE = "",
			RANGE_MISSED = "",
			RANGE_MISSED_ABSORB = "",
			RANGE_MISSED_BLOCK = "",
			RANGE_MISSED_DEFLECT = "",
			RANGE_MISSED_DODGE = "",
			RANGE_MISSED_EVADE = "",
			RANGE_MISSED_IMMUNE = "",
			RANGE_MISSED_MISS = "",
			RANGE_MISSED_PARRY = "",
			RANGE_MISSED_RESIST = "",
			SPELL_AURA_APPLIED = "++",
			SPELL_AURA_APPLIED_BUFF = "++",
			SPELL_AURA_APPLIED_DEBUFF = "++",
			SPELL_AURA_APPLIED_DOSE = "++",
			SPELL_AURA_APPLIED_DOSE_BUFF = "++",
			SPELL_AURA_APPLIED_DOSE_DEBUFF = "++",
			SPELL_AURA_BROKEN = "!-",
			SPELL_AURA_BROKEN_BUFF = "!-",
			SPELL_AURA_BROKEN_DEBUFF = "!-",
			SPELL_AURA_BROKEN_SPELL_BUFF = "!-",
			SPELL_AURA_BROKEN_SPELL_DEBUFF = "!-",
			SPELL_AURA_REFRESH = "~+",
			SPELL_AURA_REFRESH_BUFF = "~+",
			SPELL_AURA_REFRESH_DEBUFF = "~+",
			SPELL_AURA_REMOVED = "--",
			SPELL_AURA_REMOVED_BUFF = "--",
			SPELL_AURA_REMOVED_DEBUFF = "--",
			SPELL_AURA_REMOVED_DOSE = "~-",
			SPELL_AURA_REMOVED_DOSE_BUFF = "~-",
			SPELL_AURA_REMOVED_DOSE_DEBUFF = "~-",
			SPELL_BUILDING_DAMAGE = "",
			SPELL_BUILDING_HEAL = "",
			SPELL_CAST_FAILED = ACTION_SPELL_CAST_FAILED,
			SPELL_CAST_START = ACTION_SPELL_CAST_START,
			SPELL_CAST_SUCCESS = ACTION_SPELL_CAST_SUCCESS,
			SPELL_CREATE = ACTION_SPELL_CREATE, -- Created a trap, a soul well, etc.
			SPELL_DAMAGE = "",
			SPELL_DISPEL = L["dispel"],
			SPELL_DISPEL_BUFF = L["dispel"],
			SPELL_DISPEL_DEBUFF = L["cleanse"],
			SPELL_DISPEL_FAILED = ACTION_SPELL_DISPEL_FAILED,
			SPELL_DRAIN = L["drain"],
			SPELL_DURABILITY_DAMAGE = ACTION_SPELL_DURABILITY_DAMAGE,
			SPELL_DURABILITY_DAMAGE_ALL = ACTION_SPELL_DURABILITY_DAMAGE_ALL,
			SPELL_ENERGIZE = "",
			SPELL_EXTRA_ATTACKS = ACTION_SPELL_EXTRA_ATTACKS,
			SPELL_HEAL = "",
			SPELL_INSTAKILL = ACTION_SPELL_INSTAKILL,
			SPELL_INTERRUPT = L["interrupt"],
			SPELL_LEECH = L["drain"],
			SPELL_MISSED = "",
			SPELL_MISSED_ABSORB = "",
			SPELL_MISSED_BLOCK = "",
			SPELL_MISSED_DEFLECT = "",
			SPELL_MISSED_DODGE = "",
			SPELL_MISSED_EVADE = "",
			SPELL_MISSED_IMMUNE = "",
			SPELL_MISSED_MISS = "",
			SPELL_MISSED_PARRY = "",
			SPELL_MISSED_REFLECT = "",
			SPELL_MISSED_RESIST = "",
			SPELL_PERIODIC_DAMAGE = L["Dot"],
			SPELL_PERIODIC_DRAIN = L["drain"],
			SPELL_PERIODIC_ENERGIZE = "",
			SPELL_PERIODIC_HEAL = "",
			SPELL_PERIODIC_LEECH = L["drain"],
			SPELL_PERIODIC_MISSED = "",
			SPELL_PERIODIC_MISSED_ABSORB = "",
			SPELL_PERIODIC_MISSED_BLOCK = "",
			SPELL_PERIODIC_MISSED_DEFLECTED = "",
			SPELL_PERIODIC_MISSED_DODGE = "",
			SPELL_PERIODIC_MISSED_EVADED = "",
			SPELL_PERIODIC_MISSED_IMMUNE = "",
			SPELL_PERIODIC_MISSED_MISS = "",
			SPELL_PERIODIC_MISSED_PARRY = "",
			SPELL_PERIODIC_MISSED_RESIST = "",
			SPELL_RESURRECT = L["resurrect"],
			SPELL_STOLEN = L["steal"],
			SPELL_STOLEN_BUFF = L["steal"],
			SPELL_STOLEN_DEBUFF = L["steal"],
			SPELL_SUMMON = L["summon"],
			SWING = ACTION_SWING,
			SWING_DAMAGE = "",
			SWING_MISSED = "",
			SWING_MISSED_ABSORB = "",
			SWING_MISSED_BLOCK = "",
			SWING_MISSED_DEFLECT = "",
			SWING_MISSED_DODGE = "",
			SWING_MISSED_EVADE = "",
			SWING_MISSED_IMMUNE = "",
			SWING_MISSED_MISS = "",
			SWING_MISSED_PARRY = "",
			SWING_MISSED_RESIST = "",
			UNIT_DESTROYED = L["destroy"],
			UNIT_DIED = ACTION_UNIT_DIED,
			
			STRING_1 = "%s %s %s %s %s %s";
			STRING_2 = "%1$s %3$s %2$s %4$s %5$s. %6$s";
			STRING_3 = "%1$s %5$s %3$s %4$s %2$s. %6$s";
			STRING_BRACE_ITEM = "|c%s[|r%s|c%s]|r",
			STRING_BRACE_SPELL = "|c%s[|r%s|c%s]|r",
			STRING_BRACE_UNIT = "|c%s[|r%s|c%s]|r",
			STRING_VALUE_SCHOOL = "%s %s",
			STRING_VALUE_TYPE = "%s (%s)",

			STRING_RESULT_ABSORB = "(A%d)",
			STRING_RESULT_BLOCK = "(B%d)",
			STRING_RESULT_CRITICAL = L["Crit"],
			STRING_RESULT_CRITICAL_SPELL = L["Crit"], -- For Spell Critical
			STRING_RESULT_CRUSHING = L["Crush"],
			STRING_RESULT_DEFLECT = L["Deflect"],
			STRING_RESULT_DODGE = L["Dodge"],
			STRING_RESULT_EVADE = L["Evade"],
			STRING_RESULT_GLANCING = L["Glancing"],
			STRING_RESULT_IMMUNE = L["Immune"],
			STRING_RESULT_MISS = L["Miss"],
			STRING_RESULT_OVERHEALING = "(+%d)",
			STRING_RESULT_OVERKILLING = "(+%d)",
			STRING_RESULT_PARRY = L["Parry"],
			STRING_RESULT_REFLECT = L["Reflect"],
			STRING_RESULT_RESIST = "(R%d)",
			STRING_RESULT_VULNERABILITY = "(%d+)",
			
		},
		
		unitColors = {
			[1297] = { -- Player
				["r"] = 0.50,
				["g"] = 0.50,
				["b"] = 1.00,
			},
			[4983] = { -- Pet
				["r"] = 0.50,
				["g"] = 0.30,
				["b"] = 0.15,
			},
			[1396] = { -- Raid
				["r"] = 1.00,
				["g"] = 0.44,
				["b"] = 0.20,
			},
			[1394] = { -- Party
				["r"] = 0.65,
				["g"] = 1.00,
				["b"] = 0.65,
			},
			-- Target
			--[[[65536] = { 
				["r"] = 1.00,
				["g"] = 0.46,
				["b"] = 1.00,
			},]]
			[32616] = { -- Enemy
				["r"] = 1.00,
				["g"] = 0.46,
				["b"] = 1.00,
			},
			[8467] = { -- Guardian
				["r"] = 0.25,
				["g"] = 0.25,
				["b"] = 0.50,
			},
			[131072] = { -- Focus
				["r"] = 0.80,
				["g"] = 0.33,
				["b"] = 0.85,
			},
			[32632] = { -- Outsider
				["r"] = 1.00,
				["g"] = 1.00,
				["b"] = 1.00,
			},
		},
		spellColors = {
			physical = {
				["r"] = 1.00,
				["g"] = 1.00,
				["b"] = 1.00,
			},
			holy = {
				["r"] = 1.00,
				["g"] = 1.00,
				["b"] = 0.30,
			},
			fire = {
				["r"] = 1.00,
				["g"] = 0.15,
				["b"] = 0.18,
			},
			nature = {
				["r"] = 0.40,
				["g"] = 1.00,
				["b"] = 0.40,
			},
			frost = {
				["r"] = 0.30,
				["g"] = 0.30,
				["b"] = 0.90,
			},
			shadow = {
				["r"] = 1.00,
				["g"] = 0.70,
				["b"] = 1.00,
			},
			arcane = {
				["r"] = 0.75,
				["g"] = 0.75,
				["b"] = 0.75,
			},
			natureshadow = {
				["r"] = 0.70,
				["g"] = 0.85,
				["b"] = 0.70,
			},
			frostfire = {
				["r"] = 0.65,
				["g"] = 0.23,
				["b"] = 0.59,
			},
		},
		otherColors = {
			heal = {
				["r"] = 1.00,
				["g"] = 1.00,
				["b"] = 0.30,
			},
			miss = {
				["r"] = 1.00,
				["g"] = 0.5,
				["b"] = 0.5,
			},
			buff = {
				["r"] = 0.20,
				["g"] = 1.00,
				["b"] = 0.20,
			},
			debuff = {
				["r"] = 1.00,
				["g"] = 0.20,
				["b"] = 0.20,
			},
			skill = {
				["r"] = 1.00,
				["g"] = 1.00,
				["b"] = 0.4,
			},
			timestampColor = {
				r = 0.45,
				g = 0.45,
				b = 0.45,
			},
		},
	}
}

local SPELL_STOLEN = ACTION_SPELL_STOLEN
local SPELL_STOLEN_BUFF = ACTION_SPELL_STOLEN_BUFF
local SPELL_STOLEN_DEBUFF = ACTION_SPELL_STOLEN_DEBUFF

function YurrCombatLog:Config()

	self.db = LibStub("AceDB-3.0"):New("YurrCombatLogDB", defaults, "Default")
	self:CreateConfig()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("YurrCombatLog", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("YurrCombatLog", "YurrCombatLog")
	options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	self:ParseFilters()
	
	EVENT_TEMPLATE_FORMATS = {
		["SPELL_AURA_BROKEN_SPELL"] = STRING_3,
		["SPELL_CAST_START"] = STRING_2,
		["SPELL_CAST_SUCCESS"] = STRING_2
	}

end

function YurrCombatLog:CreateConfig()
	options = {
		type = "group",
		name = "YurrCombatLog",
		childGroups = "tree",
		handler = YurrCombatLog,
		args = {
			general = {
				type = "group",
				name = "General",
				order = 1,
				--inline = true,
				args = {
					chatFrame = {
						type = "select",
						name = L["ChatFrame"],
						desc = "Select where you want your CombatLog output.",
						values = { "ChatFrame1", "ChatFrame2", "ChatFrame3", "ChatFrame4", "ChatFrame5", "ChatFrame6", "ChatFrame7" },
						order = 1,
						get = function()
							return self.db.profile.ChatFrame
						end,
						set = function(info, value)
							outputFrame:Clear() -- Clear old outputFrame
							outputFrame = self:ChatFrame(value)
							self:Refilter()
							self.db.profile.ChatFrame = value
						end,
					},
					QuickButtonFrameHide = {
						type = "toggle",
						name = "Hide QuickButtonFrame",
						order = 2,
						get = function()
							return self.db.profile.QuickButtonFrameHide
						end,
						set = function(info, value)
							self.db.profile.QuickButtonFrameHide = value
							self:ChatFrame()
						end,
					},
					timestamp = {
						type = "toggle",
						name = "Timestamp",
						order = 3,
						get = function()
							return self.db.profile.timestamp
						end,
						set = function(info, value)
							self.db.profile.timestamp = value
						end,
					},
					timestampColor = {
						type = "color",
						name = "Timestamp Color",
						order = 4,
						get = function(info)
							return
							self.db.profile.otherColors.timestampColor.r, 
							self.db.profile.otherColors.timestampColor.g, 
							self.db.profile.otherColors.timestampColor.b
						end,
						set = function(info, r, g, b)
							self.db.profile.otherColors.timestampColor = { ["r"]=r, ["g"]=g, ["b"]=b }
						end,
					},
					timestampFormat = {
						type = "input",
						name = "Timestamp Format",
						order = 5,
						get = function()
							return self.db.profile.timestampFormat
						end,
						set = function(info, value)
							self.db.profile.timestampFormat = value
						end,
					},

					-- ninjad from Prat-3.0
					helpheader = {
						name = "Timestamp Format String Arguments",
						type = "header",
						order = 6,
					},
					help = {
						type = "description",
						name =
							[[     %A    is replaced by national representation of the full weekday name.

     %a    is replaced by national representation of the abbreviated weekday
           name.

     %B    is replaced by national representation of the full month name.

     %b    is replaced by national representation of the abbreviated month
           name.

     %C    is replaced by (year / 100) as decimal number; single digits are
           preceded by a zero.

     %c    is replaced by national representation of time and date.

     %D    is equivalent to ``%m/%d/%y''.

     %d    is replaced by the day of the month as a decimal number (01-31).

     %e    is replaced by the day of month as a decimal number (1-31); single
           digits are preceded by a blank.

     %F    is equivalent to ``%Y-%m-%d''.

     %G    is replaced by a year as a decimal number with century.  This year
           is the one that contains the greater part of the week (Monday as
           the first day of the week).

     %g    is replaced by the same year as in ``%G'', but as a decimal number
           without century (00-99).

     %H    is replaced by the hour (24-hour clock) as a decimal number
           (00-23).

     %h    the same as %b.

     %I    is replaced by the hour (12-hour clock) as a decimal number
           (01-12).

     %j    is replaced by the day of the year as a decimal number (001-366).

     %k    is replaced by the hour (24-hour clock) as a decimal number (0-23);
           single digits are preceded by a blank.

     %l    is replaced by the hour (12-hour clock) as a decimal number (1-12);
           single digits are preceded by a blank.

     %M    is replaced by the minute as a decimal number (00-59).

     %m    is replaced by the month as a decimal number (01-12).

     %n    is replaced by a newline.

     %O*   the same as %E*.

     %p    is replaced by national representation of either "ante meridiem" or
           "post meridiem" as appropriate.

     %R    is equivalent to ``%H:%M''.

     %r    is equivalent to ``%I:%M:%S %p''.

     %S    is replaced by the second as a decimal number (00-60).

     %s    is replaced by the number of seconds since the Epoch, UTC (see
           mktime(3)).

     %T    is equivalent to ``%H:%M:%S''.

     %t    is replaced by a tab.

     %U    is replaced by the week number of the year (Sunday as the first day
           of the week) as a decimal number (00-53).

     %u    is replaced by the weekday (Monday as the first day of the week) as
           a decimal number (1-7).

     %V    is replaced by the week number of the year (Monday as the first day
           of the week) as a decimal number (01-53).  If the week containing
           January 1 has four or more days in the new year, then it is week 1;
           otherwise it is the last week of the previous year, and the next
           week is week 1.

     %v    is equivalent to ``%e-%b-%Y''.

     %W    is replaced by the week number of the year (Monday as the first day
           of the week) as a decimal number (00-53).

     %w    is replaced by the weekday (Sunday as the first day of the week) as
           a decimal number (0-6).

     %X    is replaced by national representation of the time.

     %x    is replaced by national representation of the date.

     %Y    is replaced by the year with century as a decimal number.

     %y    is replaced by the year without century as a decimal number
           (00-99).

     %Z    is replaced by the time zone name.

     %z    is replaced by the time zone offset from UTC; a leading plus sign
           stands for east of UTC, a minus sign for west of UTC, hours and
           minutes follow with two digits each and no delimiter between them
           (common form for RFC 822 date headers).

     %+    is replaced by national representation of the date and time (the
           format is similar to that produced by date(1)).

     %%    is replaced by `%'.]],
						order = 7,
					},
				},
			},
			filters = {
			type = "group",
			order = 2,
			name = L["Filters"],
				args = {
					newFilter = {
						type = "input",
						order = 1,
						name = L["newFilter"],
						get = function()
							return
						end,
						set = "addFilter",
					},
					
				},
			},
			misc = {
				type = "group",
				order = 3,
				name = L["Events"],
				args = {
					misc = {
						type = "group",
						name = L["Events"],
						order = 1,
						inline = true,
						args = {
							experience = {
								type = "toggle",
								order = 1,
								name = COMBAT_XP_GAIN,
								set = "setMisc",
								get = "getMisc",
							},
							combat = {
								type = "toggle",
								order = 1,
								name = COMBAT,
								get = function()
								return self.db.profile.misc.combat
							end,
							set = function(info, value)
								self.db.profile.misc.combat = value
							end,
							},
							faction = {
								type = "toggle",
								order = 1,
								name = FACTION,
								get = function()
								return self.db.profile.misc.faction
							end,
							set = function(info, value)
								self.db.profile.misc.faction = value
							end,
							},
							skill = {
								type = "toggle",
								order = 1,
								name = L["Skill"],
								get = function()
								return self.db.profile.misc.skill
							end,
							set = function(info, value)
								self.db.profile.misc.skill = value
							end,
							},
							honor = {
								type = "toggle",
								order = 1,
								name = L["Honor"],
								get = function()
								return self.db.profile.misc.honor
							end,
							set = function(info, value)
								self.db.profile.misc.honor = value
							end,
							},
						},
					},
				},
			},
			colors = {
			type = "group",
			name = L["Colors"],
			order = 4,
				args = {
					unitColors = {
					type = "group",
					name = L["Unit Colors"],
					inline = true,
					order = 1,
						args = {
							["1297"] = { -- Player
								type = "color",
								name = PLAYER,
								set = "setColor",
								get = "getColor",
								order = 1,
							},
							["4983"] = { -- Pet
								type = "color",
								name = PET,
								set = "setColor",
								get = "getColor",
								order = 2,
							},
							["1396"] = { -- Raid
								type = "color",
								name = RAID,
								set = "setColor",
								get = "getColor",
								order = 3,
							},
							["1394"] = { -- Party
								type = "color",
								name = PARTY,
								set = "setColor",
								get = "getColor",
								order = 4,
							},
							-- Target
							--[[["65536"] = { 
								type = "color",
								name = TARGET,
								set = "setColor",
								get = "getColor",
								order = 5,
							},]]
							["32616"] = { -- Enemy
								type = "color",
								name = L["Enemy"],
								set = "setColor",
								get = "getColor",
								order = 5,
							},
							["8467"] = { -- Guardian
								type = "color",
								name = L["Guardian"],
								set = "setColor",
								get = "getColor",
								order = 6,
							},
							["131072"] = { -- Focus
								type = "color",
								name = FOCUS,
								set = "setColor",
								get = "getColor",
								order = 7,
							},
							["32632"] = { -- Outsider
								type = "color",
								name = L["Outsider"],
								set = "setColor",
								get = "getColor",
								order = 8,
							},
						}
					},
					spellColors = {
					type = "group",
					name = L["Spell Colors"],
					inline = true,
					order = 2,
						args = {
							physical = {
								type = "color",
								name = L["Physical"],
								set = "setColor",
								get = "getColor",
								order = 1,
							},
							holy = {
								type = "color",
								name = L["Holy"],
								set = "setColor",
								get = "getColor",
								order = 2,
							},
							fire = {
								type = "color",
								name = L["Fire"],
								set = "setColor",
								get = "getColor",
								order = 3,
							},
							nature = {
								type = "color",
								name = L["Nature"],
								set = "setColor",
								get = "getColor",
								order = 4,
							},
							frost = {
								type = "color",
								name = L["Frost"],
								set = "setColor",
								get = "getColor",
								order = 5,
							},
							shadow = {
								type = "color",
								name = L["Shadow"],
								set = "setColor",
								get = "getColor",
								order = 6,
							},
							arcane = {
								type = "color",
								name = L["Arcane"],
								set = "setColor",
								get = "getColor",
								order = 7,
							},
							natureshadow = {
								type = "color",
								name = L["Nature+shadow"],
								set = "setColor",
								get = "getColor",
								order = 8,
							},
							frostfire = {
								type = "color",
								name = L["Frost+Fire"],
								set = "setColor",
								get = "getColor",
								order = 9,
							},
						}
					},
					otherColors = {
					type = "group",
					name = L["Other Colors"],
					inline = true,
					order = 3,
						args = {
							heal = {
								type = "color",
								name = L["Heal"],
								set = "setColor",
								get = "getColor",
								order = 1,
							},
							miss = {
								type = "color",
								name = MISS,
								set = "setColor",
								get = "getColor",
								order = 2,
							},
							buff = {
								type = "color",
								name = L["Buff"],
								set = "setColor",
								get = "getColor",
								order = 3,
							},
							debuff = {
								type = "color",
								name = L["Debuff"],
								set = "setColor",
								get = "getColor",
								order = 4,
							},
							skill = {
								type = "color",
								name = L["Skill"],
								set = "setColor",
								get = "getColor",
								order = 5,
							},
						}
					}
				}
			},
			format = {
				type = "group",
				name = L["Formatting"],
				order = 5,
				args = {
					actionstring = {
						type = "group",
						name = L["Actionstring"],
						childGroups = "tab",
						args = {
							SPELL_AURA = {
								type = "group",
								name = L["Aura"],
								args = {
									SPELL_AURA_APPLIED_BUFF = {
										type = "input",
										name = L["Buff"],
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									SPELL_AURA_APPLIED_DEBUFF = {
										type = "input",
										name = L["Debuff"],
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									SPELL_AURA_APPLIED_DOSE_BUFF = {
										type = "input",
										name = L["Buff"].." "..ACTION_SPELL_AURA_APPLIED_DOSE_BUFF,
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									SPELL_AURA_APPLIED_DOSE_DEBUFF = {
										type = "input",
										name = L["Debuff"].." "..ACTION_SPELL_AURA_APPLIED_DOSE_DEBUFF,
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									SPELL_AURA_BROKEN_BUFF = {
										type = "input",
										name = L["Buff"].." "..ACTION_SPELL_AURA_BROKEN_BUFF,
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									SPELL_AURA_BROKEN_DEBUFF = {
										type = "input",
										name = L["Debuff"].." "..ACTION_SPELL_AURA_BROKEN_DEBUFF,
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									SPELL_AURA_BROKEN_SPELL_BUFF = {
										type = "input",
										name = L["Buff"].." "..L["Spell"].." "..ACTION_SPELL_AURA_BROKEN_SPELL_BUFF,
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									SPELL_AURA_BROKEN_SPELL_DEBUFF = {
										type = "input",
										name = L["Debuff"].." "..L["Spell"].." "..ACTION_SPELL_AURA_BROKEN_SPELL_DEBUFF,
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									SPELL_AURA_REFRESH_BUFF = {
										type = "input",
										name = L["Buff"].." "..ACTION_SPELL_AURA_REFRESH_BUFF,
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									SPELL_AURA_REMOVED_BUFF = {
										type = "input",
										name = L["Buff"].." "..ACTION_SPELL_AURA_REMOVED_BUFF,
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									SPELL_AURA_REMOVED_DEBUFF = {
										type = "input",
										name = L["Debuff"].." "..ACTION_SPELL_AURA_REMOVED_DEBUFF,
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									SPELL_AURA_REMOVED_DOSE_BUFF = {
										type = "input",
										name = L["Buff"].." "..ACTION_SPELL_AURA_REMOVED_DOSE_BUFF,
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									SPELL_AURA_REMOVED_DOSE_DEBUFF = {
										type = "input",
										name = L["Debuff"].." "..ACTION_SPELL_AURA_REMOVED_DOSE_DEBUFF,
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									SPELL_DISPEL_BUFF = {
										type = "input",
										name = ACTION_SPELL_DISPEL_BUFF.." "..L["Buff"],
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									SPELL_DISPEL_DEBUFF = {
										type = "input",
										name = ACTION_SPELL_DISPEL_DEBUFF.." "..L["Debuff"],
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									SPELL_DISPEL_FAILED = {
										type = "input",
										name = ACTION_SPELL_DISPEL_FAILED,
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
								},
							},
							ENVIRONMENTAL = {
								type = "group",
								name = L["Environment"],
								args = {
									ENVIRONMENTAL_DAMAGE_DROWNING = {
										type = "input",
										name = L["Drown"],
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									ENVIRONMENTAL_DAMAGE_FALLING = {
										type = "input",
										name = L["Fall"],
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									ENVIRONMENTAL_DAMAGE_FATIGUE = {
										type = "input",
										name = ACTION_ENVIRONMENTAL_DAMAGE_FATIGUE,
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									ENVIRONMENTAL_DAMAGE_FIRE = {
										type = "input",
										name = ACTION_ENVIRONMENTAL_DAMAGE_FIRE,
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									ENVIRONMENTAL_DAMAGE_LAVA = {
										type = "input",
										name = ACTION_ENVIRONMENTAL_DAMAGE_LAVA,
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									ENVIRONMENTAL_DAMAGE_SLIME = {
										type = "input",
										name = ACTION_ENVIRONMENTAL_DAMAGE_SLIME,
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
								},
							},
							SPELL = {
								type = "group",
								name = L["Spell"],
								args = {
									cast = {
										type = "group",
										name = L["Cast"],
										args = {
											SPELL_DAMAGE = {
												type = "input",
												name = L["Hit"],
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_CAST_FAILED = {
												type = "input",
												name = L["Cast"].." "..L["failed"],
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_CAST_START = {
												type = "input",
												name = L["Cast"],
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_CAST_SUCCESS = {
												type = "input",
												name = L["Cast"],
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_SUMMON = {
												type = "input",
												name = ACTION_SPELL_SUMMON,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_STOLEN = {
												type = "input",
												name = L["Spellstolen"],
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_MISSED = {
												type = "input",
												name = ACTION_SPELL_MISSED,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_REFLECT = {
												type = "input",
												name = L["Reflect"],
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_LEECH = {
												type = "input",
												name = L["Leech"],
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_INTERRUPT = {
												type = "input",
												name = ACTION_SPELL_INTERRUPT,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_HEAL = {
												type = "input",
												name = ACTION_SPELL_HEAL,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_EXTRA_ATTACKS = {
												type = "input",
												name = ACTION_SPELL_EXTRA_ATTACKS,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_ENERGIZE = {
												type = "input",
												name = ACTION_SPELL_ENERGIZE,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_DRAIN = {
												type = "input",
												name = ACTION_SPELL_DRAIN,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_DAMAGE = {
												type = "input",
												name = ACTION_SPELL_DAMAGE,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_CREATE = {
												type = "input",
												name = ACTION_SPELL_CREATE,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
										},
									},
									DAMAGE_SHIELD = {
										type = "group",
										name = L["Damage shields"],
										args = {
											DAMAGE_SHIELD = {
												type = "input",
												name = L["Hit"],
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											DAMAGE_SHIELD_MISSED_BLOCK = {
												type = "input",
												name = ACTION_DAMAGE_SHIELD_MISSED_BLOCK,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											DAMAGE_SHIELD_MISSED_DEFLECT = {
												type = "input",
												name = ACTION_DAMAGE_SHIELD_MISSED_DEFLECT,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											DAMAGE_SHIELD_MISSED_DODGE = {
												type = "input",
												name = ACTION_DAMAGE_SHIELD_MISSED_DODGE,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											DAMAGE_SHIELD_MISSED_EVADED = {
												type = "input",
												name = ACTION_DAMAGE_SHIELD_MISSED_EVADED,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											DAMAGE_SHIELD_MISSED_IMMUNE = {
												type = "input",
												name = ACTION_DAMAGE_SHIELD_MISSED_IMMUNE,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											DAMAGE_SHIELD_MISSED_MISS = {
												type = "input",
												name = ACTION_DAMAGE_SHIELD_MISSED_MISS,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											DAMAGE_SHIELD_MISSED_REFLECT = {
												type = "input",
												name = L["Reflect"],
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											DAMAGE_SHIELD_MISSED_PARRY = {
												type = "input",
												name = ACTION_DAMAGE_SHIELD_MISSED_PARRY,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											DAMAGE_SHIELD_MISSED_RESIST = {
												type = "input",
												name = ACTION_DAMAGE_SHIELD_MISSED_RESIST,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
										},
									},
									SPELL_PERIODIC = {
										type = "group",
										name = L["Periodic"],
										args = {
											SPELL_PERIODIC_DAMAGE = {
												type = "input",
												name = L["Hit"],
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_PERIODIC_DRAIN = {
												type = "input",
												name = ACTION_SPELL_PERIODIC_DRAIN,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_PERIODIC_ENERGIZE = {
												type = "input",
												name = ACTION_SPELL_PERIODIC_ENERGIZE,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_PERIODIC_HEAL = {
												type = "input",
												name = ACTION_SPELL_PERIODIC_HEAL,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_PERIODIC_LEECH = {
												type = "input",
												name = L["Leech"],
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_PERIODIC_MISSED = {
												type = "input",
												name = ACTION_SPELL_PERIODIC_MISSED.." "..L["Periodic"],
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											SPELL_PERIODIC_DAMAGE = {
												type = "input",
												name = ACTION_SPELL_DAMAGE.." "..L["Periodic"],
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
										},
									},
									ENCHANT = {
										type = "group",
										name = L["Enchant"],
										args = {
											ENCHANT_APPLIED = {
												type = "input",
												name = ACTION_ENCHANT_APPLIED,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
											ENCHANT_REMOVED = {
												type = "input",
												name = ACTION_ENCHANT_REMOVED,
												get = function(info) return self.db.profile.format[info[#info]] end,
												set = function(info, value) self.db.profile.format[info[#info]] = value end,
											},
										},
									},
								},
							},
							SWING = {
								type = "group",
								name = ACTION_SWING,
								args = {
									SWING_DAMAGE = {
										type = "input",
										name = ACTION_SWING_DAMAGE.." "..L["Melee"],
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									SWING_MISSED = {
										type = "input",
										name = ACTION_SWING_MISSED.." "..L["Melee"],
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
								},
							},
							RANGED = {
								type = "group",
								name = ACTION_RANGED,
								args = {
									RANGE_MISSED = {
										type = "input",
										name = ACTION_RANGE_MISSED.." "..L["Ranged"],
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
									RANGE_DAMAGE = {
										type = "input",
										name = ACTION_RANGE_DAMAGE.." "..L["Ranged"],
										get = function(info) return self.db.profile.format[info[#info]] end,
										set = function(info, value) self.db.profile.format[info[#info]] = value end,
									},
								},
							},
						},
					},
					resultstring = {
						type = "group",
						name = L["Resultstring"],
						childGroups = "tab",
						args = {
							STRING_RESULT_ABSORB = {
								type = "input",
								name = L["Absorb"],
								get = function(info) return self.db.profile.format[info[#info]] end,
								set = function(info, value) self.db.profile.format[info[#info]] = value end,
							},
							STRING_RESULT_BLOCK = {
								type = "input",
								name = L["Block"],
								get = function(info) return self.db.profile.format[info[#info]] end,
								set = function(info, value) self.db.profile.format[info[#info]] = value end,
							},
							STRING_RESULT_CRITICAL = {
								type = "input",
								name = L["Crit"],
								get = function(info) return self.db.profile.format[info[#info]] end,
								set = function(info, value) self.db.profile.format[info[#info]] = value end,
							},
							STRING_RESULT_CRITICAL_SPELL = {
								type = "input",
								name = L["Spell"].." "..L["Crit"],
								get = function(info) return self.db.profile.format[info[#info]] end,
								set = function(info, value) self.db.profile.format[info[#info]] = value end,
							},
							STRING_RESULT_CRUSHING = {
								type = "input",
								name = L["Crush"],
								get = function(info) return self.db.profile.format[info[#info]] end,
								set = function(info, value) self.db.profile.format[info[#info]] = value end,
							},
							STRING_RESULT_GLANCING = {
								type = "input",
								name = L["Glancing"],
								get = function(info) return self.db.profile.format[info[#info]] end,
								set = function(info, value) self.db.profile.format[info[#info]] = value end,
							},
							STRING_RESULT_OVERHEALING = {
								type = "input",
								name = L["Overhealing"],
								get = function(info) return self.db.profile.format[info[#info]] end,
								set = function(info, value) self.db.profile.format[info[#info]] = value end,
							},
							STRING_RESULT_REFLECT = {
								type = "input",
								name = L["Reflect"],
								get = function(info) return self.db.profile.format[info[#info]] end,
								set = function(info, value) self.db.profile.format[info[#info]] = value end,
							},
							STRING_RESULT_RESIST = {
								type = "input",
								name = L["Resist"],
								get = function(info) return self.db.profile.format[info[#info]] end,
								set = function(info, value) self.db.profile.format[info[#info]] = value end,
							},
							STRING_RESULT_VULNERABILITY = {
								type = "input",
								name = L["Vulnerability"],
								get = function(info) return self.db.profile.format[info[#info]] end,
								set = function(info, value) self.db.profile.format[info[#info]] = value end,
							},
						},
					},
				},
			},
	--[[		watches = {
				type = "group",
				name = L["Watches"],
				order = 6,
				args = {
					watches = {
						type = "group",
						name = L["Watches"],
						order = 1,
						inline = true,
						args = {
							addName = {
							type = "input",
							name = L["addName"],
							order = 1,
							set = function(info, value) self.db.profile.watches[value] = value
							end,
							get = function() end,
							},
							refilter = {
								type = "execute",
								name = L["Refilter"],
								width = "half",
								order = 2,
								func = function() self:Refilter() end,
							},
							removeName = {
							type = "input",
							name = L["removeName"],
							order = 3,
							set = function(info, value) self.db.profile.watches[value] = nil
							end,
							get = function() end,
							},
							listnames = {
							type = "header",
							name = function()
								local newvalue = ""
								for key,value in pairs(self.db.profile.watches) do newvalue = value..", "..newvalue end
								return newvalue
							end,
							order = 4,
							},
						},
					},
				},
			},]]
		}
	}
end

function YurrCombatLog:ParseFilters()
	
	local COMBATLOG_OBJECT_AFFILIATION_MINE = tostring(COMBATLOG_OBJECT_AFFILIATION_MINE)
	local COMBATLOG_OBJECT_AFFILIATION_PARTY = tostring(COMBATLOG_OBJECT_AFFILIATION_PARTY)
	local COMBATLOG_OBJECT_AFFILIATION_RAID = tostring(COMBATLOG_OBJECT_AFFILIATION_RAID)
	local COMBATLOG_OBJECT_AFFILIATION_OUTSIDER = tostring(COMBATLOG_OBJECT_AFFILIATION_OUTSIDER)
	local COMBATLOG_OBJECT_REACTION_FRIENDLY = tostring(COMBATLOG_OBJECT_REACTION_FRIENDLY)
	local COMBATLOG_OBJECT_REACTION_NEUTRAL = tostring(COMBATLOG_OBJECT_REACTION_NEUTRAL)
	local COMBATLOG_OBJECT_REACTION_HOSTILE = tostring(COMBATLOG_OBJECT_REACTION_HOSTILE)
	local COMBATLOG_OBJECT_CONTROL_PLAYER = tostring(COMBATLOG_OBJECT_CONTROL_PLAYER)
	local COMBATLOG_OBJECT_CONTROL_NPC = tostring(COMBATLOG_OBJECT_CONTROL_NPC)
	local COMBATLOG_OBJECT_TYPE_PLAYER = tostring(COMBATLOG_OBJECT_TYPE_PLAYER)
	local COMBATLOG_OBJECT_TYPE_NPC = tostring(COMBATLOG_OBJECT_TYPE_NPC)
	local COMBATLOG_OBJECT_TYPE_PET = tostring(COMBATLOG_OBJECT_TYPE_PET)
	local COMBATLOG_OBJECT_TYPE_GUARDIAN = tostring(COMBATLOG_OBJECT_TYPE_GUARDIAN)
	local COMBATLOG_OBJECT_TYPE_OBJECT = tostring(COMBATLOG_OBJECT_TYPE_OBJECT)
	local COMBATLOG_OBJECT_TARGET = tostring(COMBATLOG_OBJECT_TARGET)
	local COMBATLOG_OBJECT_FOCUS = tostring(COMBATLOG_OBJECT_FOCUS)

	
	local filters = self.db.profile.filters
	for key in pairs(filters) do
		local filterName = filters[key].name
		local keyString = tostring(key)
		if filterName then
			options.args.filters.args[keyString] = {
				type = "group",
				name = filterName,
				childGroups = "tab",
				args = {
					[filterName] = {
						type = "header",
						name = L["Filters for "]..filterName,
						order = 1,
					},
					events = {
						type = "group",
						name = L["Event"],
						order = 2,
						args = {
							all = {
								type = "toggle",
								name = L["All"],
								order = 1,
								width = "full",
								set = function(info, value)
									info[#info-2] = tonumber(info[#info-2])
									local events = self.db.profile.filters[info[#info-2]].filters[1].eventList
									for key in pairs (events) do
										--self.db.profile.filters.events[info[#info-2]][key] = value
										self.db.profile.filters[info[#info-2]].filters[1].eventList[key] = value
									end
									self.db.profile.allSource[info[#info-2]] = value
								end,
								get = function(info)
									info[#info-2] = tonumber(info[#info-2])
									return self.db.profile.allSource[info[#info-2]] 
								end
							},
							SWING_DAMAGE = {
								type = "toggle",
								name = L["Melee Damage"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SWING_MISSED = {
								type = "toggle",
								name = L["Melee Missed"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							RANGE_DAMAGE = {
								type = "toggle",
								name = L["Ranged Damage"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							RANGE_MISSED = {
								type = "toggle",
								name = L["Ranged Missed"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_DAMAGE = {
								type = "toggle",
								name = L["Spelldamage"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_MISSED = {
								type = "toggle",
								name = RESIST,
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_HEAL = {
								type = "toggle",
								name = SHOW_COMBAT_HEALING,
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_ENERGIZE = {
								type = "toggle",
								name = L["Energize"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_PERIODIC_MISSED = {
								type = "toggle",
								name = L["Resist(periodic)"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_PERIODIC_DAMAGE = {
								type = "toggle",
								name = L["Spelldamage(periodic)"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_PERIODIC_HEAL = {
								type = "toggle",
								name = L["Heals(periodic)"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_PERIODIC_DRAIN = {
								type = "toggle",
								name = L["Drains(periodic)"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_PERIODIC_LEECH = {
								type = "toggle",
								name = L["Leech(periodic)"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_PERIODIC_ENERGIZE = {
								type = "toggle",
								name = L["Energize(periodic)"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_DRAIN = {
								type = "toggle",
								name = DRAINS,
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_LEECH = {
								type = "toggle",
								name = L["Leech"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_INTERRUPT = {
								type = "toggle",
								name = INTERRUPTS,
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_EXTRA_ATTACKS = {
								type = "toggle",
								name = EXTRA_ATTACKS,
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_INSTAKILL = {
								type = "toggle",
								name = ACTION_SPELL_INSTAKILL,
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_DURABILITY_DAMAGE = {
								type = "toggle",
								name = ACTION_SPELL_DURABILITY_DAMAGE,
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_DURABILITY_DAMAGE_ALL = {
								type = "toggle",
								name = ACTION_SPELL_DURABILITY_DAMAGE_ALL,
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_DISPEL = {
								type = "toggle",
								name = DISPELS,
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_DISPEL_FAILED = {
								type = "toggle",
								name = DISPELS.." ("..FAILED..")",
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_STOLEN = {
								type = "toggle",
								name = L["Spellstolen"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_AURA_APPLIED = {
								type = "toggle",
								name = L["Buffs and Debuffs"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_AURA_REMOVED = {
								type = "toggle",
								name = L["Buffs/Debuffs removed"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_AURA_APPLIED_DOSE = {
								type = "toggle",
								name = L["Buffs/Debuffs (stacking)"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_AURA_REMOVED_DOSE = {
								type = "toggle",
								name = L["Buffs/Debuffs removed (stacking)"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_CAST_START = {
								type = "toggle",
								name = L["Cast start"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_CAST_SUCCESS = {
								type = "toggle",
								name = L["Cast success"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							SPELL_CAST_FAILED = {
								type = "toggle",
								name = FAILED,
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							DAMAGE_SHIELD = {
								type = "toggle",
								name = DAMAGE_SHIELD,
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							DAMAGE_SPLIT = {
								type = "toggle",
								name = ACTION_DAMAGE_SPLIT,
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							DAMAGE_SHIELD_MISSED = {
								type = "toggle",
								name = L["Damage Shield resist"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							ENCHANT_APPLIED = {
								type = "toggle",
								name = L["Enchant applied"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							ENCHANT_REMOVED = {
								type = "toggle",
								name = L["Enchant removed"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							PARTY_KILL = {
								type = "toggle",
								name = L["Party/Raid kills"],
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							UNIT_DESTROYED = {
								type = "toggle",
								name = ACTION_UNIT_DESTROYED,
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							UNIT_DIED = {
								type = "toggle",
								name = DEATHS,
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
							ENVIRONMENTAL_DAMAGE = {
								type = "toggle",
								name = ENVIRONMENTAL_DAMAGE,
								order = 1,
								set = "setEvent",
								get = "getEvent",
							},
						},
					},
					sourceFlags = {
						type = "group",
						name = L["Done by"],
						order = 4,
						args = {
							affiliation = {
								type = "group",
								name = L["Affiliation"],
								inline = true,
								order = 1,
								args = {
									[COMBATLOG_OBJECT_AFFILIATION_MINE] = {
										type = "toggle",
										name = "Player",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_AFFILIATION_PARTY] = {
										type = "toggle",
										name = "Party",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_AFFILIATION_RAID] = {
										type = "toggle",
										name = "Raid",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_AFFILIATION_OUTSIDER] = {
										type = "toggle",
										name = "Outsider",
										set = "setFlags",
										get = "getFlags",
									},
								},
							},
							reaction = {
								type = "group",
								name = L["Reaction"],
								inline = true,
								order = 2,
								args = {
									[COMBATLOG_OBJECT_REACTION_FRIENDLY] = {
										type = "toggle",
										name = "Friendly",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_REACTION_NEUTRAL] = {
										type = "toggle",
										name = "Neutral",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_REACTION_HOSTILE] = {
										type = "toggle",
										name = "Hostile",
										set = "setFlags",
										get = "getFlags",
									},
								},
							},
							Ownership = {
								type = "group",
								name = L["Ownership"],
								inline = true,
								order = 3,
								args = {
									[COMBATLOG_OBJECT_CONTROL_PLAYER] = {
										type = "toggle",
										name = "Player",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_CONTROL_NPC] = {
										type = "toggle",
										name = "NPC",
										set = "setFlags",
										get = "getFlags",
									},
								},
							},
							Unittype = {
								type = "group",
								name = L["Unit type"],
								inline = true,
								order = 4,
								args = {
									[COMBATLOG_OBJECT_TYPE_PLAYER] = {
										type = "toggle",
										name = "Player",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_TYPE_NPC] = {
										type = "toggle",
										name = "NPC",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_TYPE_PET] = {
										type = "toggle",
										name = "Pet",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_TYPE_GUARDIAN] = {
										type = "toggle",
										name = "Guardian",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_TYPE_OBJECT] = {
										type = "toggle",
										name = "Object",
										set = "setFlags",
										get = "getFlags",
									},
								},
							},
							Special = {
								type = "group",
								name = L["Special flags"],
								inline = true,
								order = 5,
								args = {
									[COMBATLOG_OBJECT_TARGET] = {
										type = "toggle",
										name = "Target",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_FOCUS] = {
										type = "toggle",
										name = "Focus",
										set = "setFlags",
										get = "getFlags",
									},
								},
							},
						},
					},
					destFlags = {
						type = "group",
						name = L["Done to"],
						order = 4,
						args = {
							affiliation = {
								type = "group",
								name = L["Affiliation"],
								inline = true,
								order = 1,
								args = {
									[COMBATLOG_OBJECT_AFFILIATION_MINE] = {
										type = "toggle",
										name = "Player",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_AFFILIATION_PARTY] = {
										type = "toggle",
										name = "Party",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_AFFILIATION_RAID] = {
										type = "toggle",
										name = "Raid",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_AFFILIATION_OUTSIDER] = {
										type = "toggle",
										name = "Outsider",
										set = "setFlags",
										get = "getFlags",
									},
								},
							},
							reaction = {
								type = "group",
								name = L["Reaction"],
								inline = true,
								order = 2,
								args = {
									[COMBATLOG_OBJECT_REACTION_FRIENDLY] = {
										type = "toggle",
										name = "Friendly",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_REACTION_NEUTRAL] = {
										type = "toggle",
										name = "Neutral",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_REACTION_HOSTILE] = {
										type = "toggle",
										name = "Hostile",
										set = "setFlags",
										get = "getFlags",
									},
								},
							},
							Ownership = {
								type = "group",
								name = L["Ownership"],
								inline = true,
								order = 3,
								args = {
									[COMBATLOG_OBJECT_CONTROL_PLAYER] = {
										type = "toggle",
										name = "Player",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_CONTROL_NPC] = {
										type = "toggle",
										name = "NPC",
										set = "setFlags",
										get = "getFlags",
									},
								},
							},
							Unittype = {
								type = "group",
								name = L["Unit type"],
								inline = true,
								order = 4,
								args = {
									[COMBATLOG_OBJECT_TYPE_PLAYER] = {
										type = "toggle",
										name = "Player",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_TYPE_NPC] = {
										type = "toggle",
										name = "NPC",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_TYPE_PET] = {
										type = "toggle",
										name = "Pet",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_TYPE_GUARDIAN] = {
										type = "toggle",
										name = "Guardian",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_TYPE_OBJECT] = {
										type = "toggle",
										name = "Object",
										set = "setFlags",
										get = "getFlags",
									},
								},
							},
							Special = {
								type = "group",
								name = L["Special flags"],
								inline = true,
								order = 5,
								args = {
									[COMBATLOG_OBJECT_TARGET] = {
										type = "toggle",
										name = "Target",
										set = "setFlags",
										get = "getFlags",
									},
									[COMBATLOG_OBJECT_FOCUS] = {
										type = "toggle",
										name = "Focus",
										set = "setFlags",
										get = "getFlags",
									},
								},
							},
						},
					},
					toggle = {
						type = "toggle",
						name = L["Toggle Filter"],
						order = 5,
						set = "applyFilter",
						get = "getFilter",
					},
					refilter = {
						type = "execute",
						name = L["Refilter"],
						order = 6,
						width = "half",
						func = function() self:Refilter() self:applyFilter() end,
					},
					removeFilter = {
						type = "execute",
						name = L["Remove this Filter"],
						order = 7,
						func = function(info)
							options.args.filters.args[info[#info-1]] = nil
							info[#info-1] = tonumber(info[#info-1])
							self.db.profile.filters[info[#info-1]] = nil
						end,
					}
				}
			}
		end
	end
end
