﻿YurrCombatLog = LibStub("AceAddon-3.0"):NewAddon("YurrCombatLog", "AceConsole-3.0", "AceEvent-3.0")
local YurrCombatLogLDB = LibStub("LibDataBroker-1.1")
local L = LibStub("AceLocale-3.0"):GetLocale("YurrCombatLog")
local Addon = LibStub("AceAddon-3.0"):GetAddon("Fortress", "silent")
local math_floor = _G.math.floor

local COMBATLOG_LIMIT_PER_FRAME = 1;
local _G = getfenv(0)
local CombatLogQuickButtonFrameProgressBar
local bit_bor = _G.bit.bor
local oldFCF_DockUpdate

local LDB = YurrCombatLogLDB:NewDataObject("YurrCombatLog", {
	launcher = true,
	icon = "Interface\\Icons\\Ability_MeleeDamage",
	label = "YurrCombatLog",
	text = "YurrCombatLog"
})

function LDB:OnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint("TOP", self, "BOTTOM")
	GameTooltip:ClearLines()
	GameTooltip:AddLine(LDB.text)
	GameTooltip:AddLine("|cffffff00"..L["LeftClick|r to open the YurrCombatLog options menu"])
	if ( Addon ) then
		GameTooltip:AddLine("|cffffff00"..L["RightClick|r to open the Fotress options menu"])
	end
	--LDB.OnTooltipShow(GameTooltip)
	GameTooltip:Show()
end

function LDB:OnClick(button)
	if button == "LeftButton" then
		LibStub("AceConfigDialog-3.0"):Open("YurrCombatLog")
	elseif ( Addon ) and button == "RightButton" then
		LibStub("AceConfigDialog-3.0"):Open("FortressYurrCombatLogLDB")
	end
end

function LDB:OnLeave()
    GameTooltip:Hide()
end

function YurrCombatLog:OnInitialize()

	-- Called when the addon is loaded
	self:Config()
	self:RegisterChatCommand("ycl", "ChatCommand")
	self:RegisterChatCommand("yurrcombatlog", "ChatCommand")
	oldFCF_DockUpdate = FCF_DockUpdate

end

function YurrCombatLog:OnEnable()

	-- Called when the addon is enabled
	self:RegisterEvent("COMBAT_LOG_EVENT")
	self:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN")
	self:RegisterEvent("CHAT_MSG_COMBAT_HONOR_GAIN")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE")
	self:RegisterEvent("ADDON_LOADED")
	self:RegisterEvent("CHAT_MSG_SKILL")
	outputFrame = self:ChatFrame(self.db.profile.ChatFrame)
	--CombatLogQuickButtonFrame_Custom:Hide()
	--Blizzard_CombatLog_AdjustCombatLogHeight = fakeFunction
	CombatLog_AddEvent = fakeFunction
	--Blizzard_CombatLog_Refilter = fakeFunction
	--COMBATLOG:SetScript("OnEvent", nil)

end

-- Message Limit

local COMBATLOG_MESSAGE_LIMIT = 300;

--Disable stuff
function YurrCombatLog:ADDON_LOADED(events, addonName)

	local config = self.db.profile.filters
	
	if addonName == "Blizzard_CombatLog" then		
		--CombatLogClearEntries()
		COMBATLOG:Clear()
		
		CombatLogQuickButtonFrameProgressBar = _G.CombatLogQuickButtonFrame_CustomProgressBar
		CombatLogQuickButtonFrameProgressBar:Hide()
		--self:Refilter()
		Blizzard_CombatLog_Refilter = function() self:Refilter() end
		
		FCF_DockUpdate = function() oldFCF_DockUpdate() end
		
		self:applyFilter()
		self:ChatFrame()
	end

end

--Hook stuff
function fakeFunction()
end

function YurrCombatLog:Refilter()
	local count = CombatLogGetNumEntries();
	
	outputFrame:SetMaxLines(COMBATLOG_MESSAGE_LIMIT);

	-- count should be between 1 and COMBATLOG_MESSAGE_LIMIT
	count = max(1, min(count, COMBATLOG_MESSAGE_LIMIT));

	CombatLogSetCurrentEntry(0);
	
	-- Clear the combat log
	outputFrame:Clear();
	
	-- Moved setting the max value here, since we don't really need to reset the max every frame, do we?
	-- We can't add events while refiltering (:AddFilter short circuits) so this should be safe optimization.
	CombatLogQuickButtonFrameProgressBar:SetMinMaxValues(0, count);
	CombatLogQuickButtonFrameProgressBar:SetValue(0);
	CombatLogQuickButtonFrameProgressBar:Show();

	-- Enable the distributed frame
	CombatLogUpdateFrame.refiltering = true;
	CombatLogUpdateFrame:SetScript("OnUpdate", function() self:RefilterUpdate() end)
	
	self:RefilterUpdate()
end

function YurrCombatLog:RefilterUpdate()
	local valid = CombatLogGetCurrentEntry()
	
	-- Clear the combat log
	local total = 0;
	while (valid and total < COMBATLOG_LIMIT_PER_FRAME) do
		-- Log to the window
		
		local output = self:ParseEvent(arg1, CombatLogGetCurrentEntry())
		if output then
			self:AddOutput(output)
		end
		
		--local text, r, g, b, a = CombatLog_OnEvent(Blizzard_CombatLog_CurrentSettings, CombatLogGetCurrentEntry());
		-- NOTE: be sure to pass in nil for the color id or the color id may override the r, g, b values for this message
		--COMBATLOG:AddMessage( text, r, g, b, nil, true );
		
		
		valid = CombatLogAdvanceEntry(-1)
		total = total + 1;
	end
	
	CombatLogQuickButtonFrameProgressBar:SetValue(CombatLogQuickButtonFrameProgressBar:GetValue() + total);

	if ( not valid or (CombatLogQuickButtonFrameProgressBar:GetValue() >= COMBATLOG_MESSAGE_LIMIT) ) then
		CombatLogUpdateFrame.refiltering = false
		CombatLogUpdateFrame:SetScript("OnUpdate", nil)
		CombatLogQuickButtonFrameProgressBar:Hide();
	end
end

function YurrCombatLog:ChatFrame(frame)

	if frame == 1 then
		frame = ChatFrame1
	elseif frame == 2 then
		frame = ChatFrame2
	elseif frame == 3 then
		frame = ChatFrame3
	elseif frame == 4 then
		frame = ChatFrame4
	elseif frame == 5 then
		frame = ChatFrame5
	elseif frame == 6 then
		frame = ChatFrame6
	elseif frame == 7 then
		frame = ChatFrame7
	end
	
	if frame == nil then
		frame = outputFrame
	end
	
	CombatLogQuickButtonFrame_Custom:SetParent(frame:GetName() .. "Tab")
	CombatLogQuickButtonFrame_Custom:ClearAllPoints();
	CombatLogQuickButtonFrame_Custom:SetPoint("TOP", frame:GetName() .. "Tab", "BOTTOM", 0 , -2)
	CombatLogQuickButtonFrame_Custom:SetPoint("RIGHT", frame, "RIGHT", 0, 0);
	CombatLogQuickButtonFrame_Custom:SetPoint("LEFT", frame, "LEFT", 0, 0);
	CombatLogQuickButtonFrame_Custom:SetFrameStrata("HIGH")
		CombatLogQuickButtonFrame_Custom:Hide()
	
	if ( self.db.profile.QuickButtonFrameHide ) then
		CombatLogQuickButtonFrame_Custom:Hide()
	else
		CombatLogQuickButtonFrame_Custom:Show()
	end
	
	return frame

end

function YurrCombatLog:ChatCommand(input)

	if not input or input:trim() == "" then
	  LibStub("AceConfigDialog-3.0"):Open("YurrCombatLog")
	else
	  LibStub("AceConfigCmd-3.0").HandleCommand(YurrCombatLog, "ycl", "YurrCombatLog", input)
	end

end

--Converts 4 floats into FF code
function YurrCombatLog:Color_FloatToText(r,g,b,a)

	if ( type(r) == "table" ) then
		r, g, b, a = r.r, r.g, r.b, r.a;
	end
	a = min(1, a or 1) * 255
	r = min(1, r) * 255
	g = min(1, g) * 255
	b = min(1, b) * 255
	
	-- local fmt = "%.2x";
	return ("%.2x%.2x%.2x%.2x"):format(math_floor(a), math_floor(r), math_floor(g), math_floor(b))

end

--Color unit by flags
function YurrCombatLog:ColorStringByUnitType(unitFlags)
	local color = self:ColorArrayByUnitType(unitFlags);
	
	return self:Color_FloatToText(color.r, color.g, color.b)
end

function YurrCombatLog:ColorArrayByUnitType(unitFlags)
	
	local color
	
	local colors = self.db.profile.unitColors
	
	for mask in pairs( colors ) do
		if ( CombatLog_Object_IsA (unitFlags, mask) )then
			color = colors[mask]
			break
		end
	end
	return color
	
end

function YurrCombatLog:SwingMissType(missType)

	local missed

	missed = (string.lower(missType))
	return missed

end

--Color anything via school
function YurrCombatLog:ColorArrayBySchool(school)

	local colors = self.db.profile.spellColors
	local color
	
	if school == 1 then
		color = colors.physical
	elseif school == 2 then
		color = colors.holy
	elseif school == 4 then
		color = colors.fire
	elseif school == 8 then
		color = colors.nature
	elseif school == 16 then
		color = colors.frost
	elseif school == 20 then
		color = colors.frostfire
	elseif school == 32 then
		color = colors.shadow
	elseif school == 40 then
		color = colors.natureshadow
	elseif school == 64 then
		color = colors.arcane
	end
	return color

end

--Color buffs by Buff/Debuff
function YurrCombatLog:ColorArrayByEventType(event)

	local colors = self.db.profile.otherColors
	local color
	
	local applied
	local removed
	--local refreshed
	local broken
	
	local buff
	local debuff
	
	local dispel
	
	local start, stop
	
	start, stop = string.find(event, "APPLIED")
	if ( start and stop ) then
		applied = string.sub(event, start, stop)
		start, stop = nil, nil
	end
	
	start, stop = string.find(event, "REMOVED")
	if ( start and stop ) then
		removed = string.sub(event, start, stop)
		start, stop = nil, nil
	end
	--refreshed = string.sub(event, string.find(event, "REFRESHED"))
	start, stop = string.find(event, "BROKEN")
	if ( start and stop ) then
		broken = string.sub(event, start, stop)
		start, stop = nil, nil
	end
	
	start, stop = string.find(event, "_BUFF")
	if ( start and stop ) then
		buff = string.sub(event, start, stop)
		start, stop = nil, nil
	end
	start, stop = string.find(event, "_DEBUFF")
	if ( start and stop ) then
		debuff = string.sub(event, start, stop)
		start, stop = nil, nil
	end
	
	if ( removed or broken ) then
		color = colors.skill
	elseif ( buff or applied ) then
		color = colors.buff
	elseif ( debuff ) then
		color = colors.debuff
	end
	
	return color

end

--Color enchants
function YurrCombatLog:EnchantColoring(enchantName, event)

	local enchant, enchantNameColored
	local colors = self.db.profile.otherColors
	local color

	if event == "ENCHANT_APPLIED" then
		color = self:Color_FloatToText(colors.skill.r, colors.skill.g, colors.skill.b)
		enchantNameColored = "|c"..color.."++"..enchantName.."|r"
	elseif event == "ENCHANT_REMOVED" then
		color = self:Color_FloatToText(colors.skill.r, colors.skill.g, colors.skill.b)
		enchantNameColored = "|c"..color.."--"..enchantName.."|r"
	end
	return enchantNameColored

end

--returns environmental damage types
function YurrCombatLog:EnvironmentalDamageType(environmentalType)

	if environmentalType == "DROWNING" then
		environmentalType = "drown"
	elseif environmentalType == "FALLING" then
		environmentalType = "fall"
	elseif environmentalType == "FATIGUE" then
		environmentalType = "fatigue"
	elseif environmentalType == "FIRE" then
		environmentalType = "fire"
	elseif environmentalType == "LAVA" then
		environmentalType = "lava"
	elseif environmentalType == "SLIME" then
		environmentalType = "slime"
	end
	return environmentalType

end

--
-- Returns a string associated with a numeric power type
--
function YurrCombatLog:powerType(powerType)
	if ( not powerType ) then
		return "";
	elseif ( powerType == SPELL_POWER_MANA ) then
		return MANA;
	elseif ( powerType == SPELL_POWER_RAGE ) then
		return RAGE;
	elseif ( powerType == SPELL_POWER_ENERGY ) then
		return ENERGY;
	elseif ( powerType == SPELL_POWER_FOCUS ) then
		return FOCUS;
	elseif ( powerType == SPELL_POWER_HAPPINESS ) then
		return HAPPINESS;
	elseif ( powerType == SPELL_POWER_RUNES ) then
		return RUNES;
	elseif ( powerType == SPELL_POWER_RUNIC_POWER ) then
		return RUNIC_POWER;
	end
end

function YurrCombatLog:DamageResult(resisted, blocked, absorbed, critical, glancing, crushing, overhealing, overkill)

	local resultStr
	local useOverhealing = overhealing and overhealing > 0;
	local useOverkill = overkill and overkill > 0;
	
	if ( resisted or blocked or absorbed or critical or glancing or crushing or useOverhealing or useOverkill) then
		resultStr = nil;
		
		if ( resisted ) then
			if ( resisted < 0 ) then	--Its really a vulnerability
				resultStr = format(self.db.profile.format.STRING_RESULT_VULNERABILITY, -resisted);
			else
				resultStr = format(self.db.profile.format.STRING_RESULT_RESIST, resisted);
			end
		end
		if ( blocked ) then
			if ( resultStr ) then
				resultStr = resultStr.." "..format(self.db.profile.format.STRING_RESULT_BLOCK, blocked);
			else
				resultStr = format(self.db.profile.format.STRING_RESULT_BLOCK, blocked);
			end
		end
		if ( absorbed ) then
			if ( resultStr ) then
				resultStr = resultStr.." "..format(self.db.profile.format.STRING_RESULT_ABSORB, absorbed);
			else
				resultStr = format(self.db.profile.format.STRING_RESULT_ABSORB, absorbed);
			end
		end
		if ( glancing ) then
			if ( resultStr ) then
				resultStr = resultStr.." "..self.db.profile.format.STRING_RESULT_GLANCING;
			else
				resultStr = self.db.profile.format.STRING_RESULT_GLANCING;
			end
		end
		if ( crushing ) then
			if ( resultStr ) then
				resultStr = resultStr.." "..self.db.profile.format.STRING_RESULT_CRUSHING;
			else
				resultStr = self.db.profile.format.STRING_RESULT_CRUSHING;
			end
		end
		if ( useOverhealing ) then
			if ( resultStr ) then
				resultStr = resultStr.." "..format(self.db.profile.format.STRING_RESULT_OVERHEALING, overhealing);
			else
				resultStr = format(self.db.profile.format.STRING_RESULT_OVERHEALING, overhealing);
			end
		end
		if ( useOverkill ) then
			if ( resultStr ) then
				resultStr = resultStr.." "..format(self.db.profile.format.STRING_RESULT_OVERKILLING, overkill);
			else
				resultStr = format(self.db.profile.format.STRING_RESULT_OVERKILLING, overkill);
			end
		end
		if ( critical ) then
			local critString = self.db.profile.format.STRING_RESULT_CRITICAL;
			if ( spellId ) then
				critString = self.db.profile.format.STRING_RESULT_CRITICAL_SPELL;
			end
			if ( resultStr ) then
				resultStr = resultStr.." "..critString;
			else
				resultStr = critString;
			end
		end
	end
	
	return resultStr

end

function YurrCombatLog:COMBAT_LOG_EVENT(arg1, ...)
	local output = self:ParseEvent(arg1, ...)
	if output then
		outputFrame:AddMessage(output)
	end
end

--parse the event
function YurrCombatLog:ParseEvent(arg1, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)

	local otherColors = self.db.profile.otherColors

	local sourceEnabled = true;
	local falseSource = false;
	local destEnabled = true;
	local spellEnabled = true;
	local actionEnabled = true;
	local valueEnabled = true;
	local valueTypeEnabled = true;
	local resultEnabled = true;
	local powerTypeEnabled = true;
	local itemEnabled = false;
	local extraSpellEnabled = false;
	local valueIsItem = false;
	
	local braceColor = "FFFFFFFF";
	
	local resultStr
	local resultEnabled = true
	
	local formatString = self.db.profile.format.STRING_1;
	if ( EVENT_TEMPLATE_FORMATS[event] ) then
		formatString = EVENT_TEMPLATE_FORMATS[event];
	end

	-- Replacements to do: 
	-- * Src, Dest, Action, Spell, Amount, Result

	-- Spell standard order
	local spellId, spellName, spellSchool;
	local extraSpellId, extraSpellName, extraSpellSchool;

	-- For Melee/Ranged swings and enchants
	local nameIsNotSpell, extraNameIsNotSpell; 

	-- Damage standard order
	local amount, overkill, spellSchool, resisted, blocked, absorbed, critical, glancing, crushing, overhealing;
	-- Miss argument order
	local missType, amountMissed;
	-- Aura arguments
	local auraType; -- BUFF or DEBUFF

	-- Enchant arguments
	local itemId, itemName;

	-- Special Spell values
	local valueType = 1;  -- 1 = School, 2 = Power Type
	local extraAmount; -- Used for Drains and Leeches
	local powerType; -- Used for energizes, drains and leeches
	local environmentalType; -- Used for environmental damage
	local message; -- Used for server spell messages
	local originalEvent = event; -- Used for spell links

	-- Generic disabling stuff
	if ( not sourceName or CombatLog_Object_IsA(sourceFlags, COMBATLOG_OBJECT_NONE) ) then
		sourceEnabled = false;
	end
	if ( not destName or CombatLog_Object_IsA(destFlags, COMBATLOG_OBJECT_NONE) ) then
		destEnabled = false;
	end
	
	local subVal = strsub(event, 1, 5)
	
	-- Swings
	if ( subVal == "SWING" ) then
		spellName = ACTION_SWING;
		nameIsNotSpell = true;
	end
	
	if ( event == "SWING_DAMAGE" ) then
		-- Damage standard
		amount, overkill, spellSchool, resisted, blocked, absorbed, critical, glancing, crushing = ...;

		-- Parse the result string
		resultStr = self:DamageResult( resisted, blocked, absorbed, critical, glancing, crushing, overhealing, overkill );

		if ( not resultStr ) then
			resultEnabled = false;
		end
		
		amount = amount - overkill;

	elseif ( event == "SWING_MISSED" ) then
		spellName = ACTION_SWING;

		-- Miss type
		missType, amountMissed = ...;

		-- Result String
		if( missType == "RESIST" or missType == "BLOCK" or missType == "ABSORB" ) then
			resultStr = format(self.db.profile.format["STRING_RESULT_"..missType], amountMissed);
		else
			resultStr = format(self.db.profile.format["STRING_RESULT_"..missType]);
		end

		-- Disable appropriate sections
		nameIsNotSpell = true;
		valueEnabled = false;
		resultEnabled = true;
		
	elseif ( subVal == "SPELL" ) then
		spellId, spellName, spellSchool = ...;
		if ( event == "SPELL_DAMAGE" or event == "SPELL_BUILDING_DAMAGE") then
			
			-- Damage standard
			amount, overkill, spellSchool, resisted, blocked, absorbed, critical, glancing, crushing = select(4, ...);

			-- Parse the result string
			resultStr = self:DamageResult( resisted, blocked, absorbed, critical, glancing, crushing, overhealing, overkill );

			if ( not resultStr ) then
				resultEnabled = false
			end
			
			amount = amount - overkill;
			
		elseif ( event == "SPELL_MISSED" ) then
			
			-- Miss type
			missType,  amountMissed = select(4, ...);

			resultEnabled = true;
			-- Result String
			if( missType == "RESIST" or missType == "BLOCK" or missType == "ABSORB" ) then
				resultStr = format(self.db.profile.format["STRING_RESULT_"..missType], amountMissed);
			else
				resultStr = self.db.profile.format["STRING_RESULT_"..missType];
			end

			-- Miss Event
			if ( missType ) then
				event = format("%s_%s", event, missType);
			end

			-- Disable appropriate sections
			valueEnabled = false;
			
		elseif ( event == "SPELL_HEAL" ) then
			
			-- Did the heal crit?
			amount, overhealing, critical = select(4, ...);
			
			-- Parse the result string
			resultStr = self:DamageResult( resisted, blocked, absorbed, critical, glancing, crushing, overhealing, textMode, spellId, overkill );

			if ( not resultStr ) then
				resultEnabled = false
			end

			-- Temporary Spell School Hack
			school = spellSchool;

			-- Disable appropriate sections
			valueEnabled = true;
			valueTypeEnabled = true;
			
			amount = amount - overhealing;
		elseif ( event == "SPELL_ENERGIZE" ) then
			-- Set value type to be a power type
			valueType = 2;

			-- Did the heal crit?
			amount, powerType = select(4, ...);
			
			-- Parse the result string
			--resultStr = getglobal(textModeString .. "RESULT");
			--resultStr = strreplace(resultStr,"$resultString", getglobal(""..event.."_RESULT")); 

			if ( not resultStr ) then
				resultEnabled = false
			end

			-- Disable appropriate sections
			valueEnabled = true;
			valueTypeEnabled = true;
		elseif ( strsub(event, 1, 14) == "SPELL_PERIODIC" ) then
		
			if ( event == "SPELL_PERIODIC_MISSED" ) then
				-- Miss type
				missType, amountMissed = select(4, ...);
				
				-- Result String
				if ( missType == "ABSORB" ) then
					resultStr = format(self.db.profile.format["STRING_RESULT_"..missType], amountMissed);
				else
					resultStr = self.db.profile.format["STRING_RESULT_"..missType];
				end

				-- Disable appropriate sections
				valueEnabled = false;
				resultEnabled = true;
			elseif ( event == "SPELL_PERIODIC_DAMAGE" ) then
				-- Damage standard
				amount, overkill, spellSchool, resisted, blocked, absorbed, critical, glancing, crushing = select(4, ...);

				-- Parse the result string
				resultStr = self:DamageResult( resisted, blocked, absorbed, critical, glancing, crushing, overhealing, overkill );

				-- Disable appropriate sections
				if ( not resultStr ) then
					resultEnabled = false
				end
				
				amount = amount - overkill;
			elseif ( event == "SPELL_PERIODIC_HEAL" ) then
				-- Did the heal crit?
				amount, overhealing, critical = select(4, ...);
				
				-- Parse the result string
				resultStr = self:DamageResult( resisted, blocked, absorbed, critical, glancing, crushing, overhealing, overkill );

				if ( not resultStr ) then
					resultEnabled = false
				end

				-- Temporary Spell School Hack
				school = school;

				-- Disable appropriate sections
				valueEnabled = true;
				valueTypeEnabled = true;
				
				amount = amount - overhealing;
			elseif ( event == "SPELL_PERIODIC_DRAIN" ) then
				-- Special attacks
				amount, powerType, extraAmount = select(4, ...);

				-- Set value type to be a power type
				valueType = 2;

				-- Result String
				--resultStr = getglobal(textModeString .. "RESULT");
				--resultStr = strreplace(resultStr,"$resultString", getglobal(""..event.."_RESULT")); 

				-- Disable appropriate sections
				if ( not resultStr ) then
					resultEnabled = false
				end
				valueEnabled = true;
				schoolEnabled = false;
			elseif ( event == "SPELL_PERIODIC_LEECH" ) then
				-- Special attacks
				amount, powerType, extraAmount = select(4, ...);

				-- Set value type to be a power type
				valueType = 2;

				-- Result String
				--resultStr = self.db.profile.format["SPELL_PERIODIC_LEECH_RESULT"]; --"($extraAmount $powerType Gained)"
				resultStr = self:DamageResult( resisted, blocked, absorbed, critical, glancing, crushing, overhealing, overkill );

				-- Disable appropriate sections
				if ( not resultStr ) then
					resultEnabled = false
				end
				valueEnabled = true;
				schoolEnabled = false;
			elseif ( event == "SPELL_PERIODIC_ENERGIZE" ) then
				-- Set value type to be a power type
				valueType = 2;

				-- Did the heal crit?
				amount, powerType = select(4, ...);
				
				-- Parse the result string
				--resultStr = getglobal(textModeString .. "RESULT");
				--resultStr = strreplace(resultStr,"$resultString", getglobal(""..event.."_RESULT")); 

				if ( not resultStr ) then
					resultEnabled = false
				end

				-- Disable appropriate sections
				valueEnabled = true;
				valueTypeEnabled = true;				
			end
		elseif ( event == "SPELL_CAST_START" ) then	-- Spellcast
			if ( not destName ) then
				destEnabled = false;
			end
			if ( not sourceName ) then
				sourceName = COMBATLOG_UNKNOWN_UNIT;
				sourceEnabled = true;
				falseSource = true;
			end

			-- Disable appropriate types
			resultEnabled = false;
			valueEnabled = false;
		elseif ( event == "SPELL_CAST_SUCCESS" ) then
			if ( not destName ) then
				destEnabled = false;
			end
			if ( not sourceName ) then
				sourceName = COMBATLOG_UNKNOWN_UNIT;
				sourceEnabled = true;
				falseSource = true;
			end

			-- Disable appropriate types
			resultEnabled = false;
			valueEnabled = false;
		elseif ( event == "SPELL_CAST_FAILED" ) then 
			if ( not destName ) then
				destEnabled = false;
			end
			-- Miss reason
			missType = select(4, ...);

			-- Result String
			resultStr = format("(%s)", missType);
			--resultStr = strreplace(self.db.profile.format[textModeString .. "RESULT"],"$resultString", missType);

			-- Disable appropriate sections
			valueEnabled = false;
			destEnabled = false;

			if ( not resultStr ) then
				resultEnabled = false;
			end
		elseif ( event == "SPELL_DRAIN" ) then		-- Special Spell effects
			-- Special attacks
			amount, powerType, extraAmount = select(4, ...);

			-- Set value type to be a power type
			valueType = 2;

			-- Disable appropriate sections
			if ( not resultStr ) then
				resultEnabled = false;
			end
			valueEnabled = true;
			schoolEnabled = false;
		elseif ( event == "SPELL_LEECH" ) then
			-- Special attacks
			amount, powerType, extraAmount = select(4, ...);

			-- Set value type to be a power type
			valueType = 2;

			-- Result String
			--resultStr = self.db.profile.format["SPELL_LEECH_RESULT"];
			resultStr = self:DamageResult( resisted, blocked, absorbed, critical, glancing, crushing, overhealing, overkill );

			-- Disable appropriate sections
			if ( not resultStr ) then
				resultEnabled = false;
			end
			valueEnabled = true;
			schoolEnabled = false;
		elseif ( event == "SPELL_INTERRUPT" ) then
			-- Spell interrupted
			extraSpellId, extraSpellName, extraSpellSchool = select(4, ...);

			-- Replace the value token with a spell token
			if ( extraSpellId ) then
				extraSpellEnabled = true;
			end

			-- Disable appropriate sections
			resultEnabled = false;
			valueEnabled = false;
			valueTypeEnabled = false;
			schoolEnabled = false;
		elseif ( event == "SPELL_EXTRA_ATTACKS" ) then
			-- Special attacks
			amount = select(4, ...);

			-- Disable appropriate sections
			resultEnabled = false;
			valueEnabled = true;
			valueTypeEnabled = false;
			schoolEnabled = false;
		elseif ( event == "SPELL_SUMMON" ) then
			-- Disable appropriate sections
			resultEnabled = false;
			valueEnabled = false;
			schoolEnabled = false;
		elseif ( event == "SPELL_RESURRECT" ) then
			-- Disable appropriate sections
			resultEnabled = false;
			valueEnabled = false;
			schoolEnabled = false;
		elseif ( event == "SPELL_CREATE" ) then
			-- Disable appropriate sections
			resultEnabled = false;
			valueEnabled = false;
			schoolEnabled = false;
		elseif ( event == "SPELL_INSTAKILL" ) then
			-- Disable appropriate sections
			resultEnabled = false;
			valueEnabled = false;
			schoolEnabled = false;
		elseif ( event == "SPELL_DURABILITY_DAMAGE" ) then
			-- Disable appropriate sections
			resultEnabled = false;
			valueEnabled = false;
			schoolEnabled = false;
		elseif ( event == "SPELL_DURABILITY_DAMAGE_ALL" ) then
			-- Disable appropriate sections
			resultEnabled = false;
			valueEnabled = false;
			schoolEnabled = false;
		elseif ( event == "SPELL_DISPEL_FAILED" ) then
			-- Extra Spell standard
			extraSpellId, extraSpellName, extraSpellSchool = select(4, ...);
			
			-- Replace the value token with a spell token
			if ( extraSpellId ) then
				extraSpellEnabled = true;
			end

			-- Disable appropriate sections
			resultEnabled = false;
			valueEnabled = false;
		elseif ( event == "SPELL_DISPEL" or event == "SPELL_STOLEN" ) then
			-- Extra Spell standard, Aura standard
			extraSpellId, extraSpellName, extraSpellSchool, auraType = select(4, ...);

			-- Event Type
			event = format("%s_%s", event, auraType);

			-- Replace the value token with a spell token
			if ( extraSpellId ) then
				extraSpellEnabled = true;
				valueEnabled = true;
			else
				valueEnabled = false;
			end

			-- Disable appropriate sections
			resultEnabled = false;
		elseif ( event == "SPELL_AURA_BROKEN" or event == "SPELL_AURA_BROKEN_SPELL") then
			
			-- Extra Spell standard, Aura standard
			if(event == "SPELL_AURA_BROKEN") then
				auraType = select(4, ...);
			else
				extraSpellId, extraSpellName, extraSpellSchool, auraType = select(4, ...);
			end
			
			-- Event Type
			event = format("%s_%s", event, auraType);

			-- Replace the value token with a spell token
			if ( extraSpellId ) then
				extraSpellEnabled = true;
				valueEnabled = true;
			else
				valueEnabled = false;
			end

			resultEnabled = false;
		elseif ( event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REMOVED" or event == "SPELL_AURA_REFRESH") then		-- Aura Events
			-- Aura standard
			auraType = select(4, ...);

			-- Event Type
			event = format("%s_%s", event, auraType);

			resultEnabled = false;
			valueEnabled = false;
		elseif ( event == "SPELL_AURA_APPLIED_DOSE" or event == "SPELL_AURA_REMOVED_DOSE" ) then
		
			-- Aura standard
			auraType, amount = select(4, ...);

			-- Abort if buff/debuff is not set to true
			if ( hideBuffs and auraType == AURA_TYPE_BUFF ) then
				return;
			elseif ( hideDebuffs and auraType == AURA_TYPE_DEBUFF ) then
				return;
			end

			-- Event Type
			event = format("%s_%s", event, auraType);

			amount = "("..amount..")"

			-- Disable appropriate sections
			resultEnabled = false;
			valueEnabled = true;
			valueTypeEnabled = false;
		end
	elseif ( subVal == "RANGE" ) then
		--spellName = ACTION_RANGED;
		--nameIsNotSpell = true;

		-- Shots are spells, technically
		spellId, spellName, spellSchool = ...;
		if ( event == "RANGE_DAMAGE" ) then 
			-- Damage standard
			amount, overkill, spellSchool, resisted, blocked, absorbed, critical, glancing, crushing = select(4, ...);

			-- Parse the result string
			resultStr = self:DamageResult( resisted, blocked, absorbed, critical, glancing, crushing, overhealing, overkill );

			if ( not resultStr ) then
				resultEnabled = false
			end

			-- Disable appropriate sections
			nameIsNotSpell = true;
			
			amount = amount - overkill;
		elseif ( event == "RANGE_MISSED" ) then 
			
			-- Miss type
			missType,  amountMissed = select(4, ...);

			resultEnabled = true;
			-- Result String
			if( missType == "RESIST" or missType == "BLOCK" or missType == "ABSORB" ) then
				resultStr = format(self.db.profile.format["STRING_RESULT_"..missType], amountMissed);
			else
				resultStr = self.db.profile.format["STRING_RESULT_"..missType];
			end

			-- Miss Event
			if ( missType ) then
				event = format("%s_%s", event, missType);
			end

			-- Disable appropriate sections
			valueEnabled = false;
		end
	elseif ( event == "DAMAGE_SHIELD" ) then	-- Damage Shields
		-- Spell standard, Damage standard
		spellId, spellName, spellSchool, amount, overkill, spellSchool, resisted, blocked, absorbed, critical, glancing, crushing = ...;

		-- Parse the result string
		resultStr = self:DamageResult( resisted, blocked, absorbed, critical, glancing, crushing, overhealing, overkill );

		-- Disable appropriate sections
		if ( not resultStr ) then
			resultEnabled = false
		end
		
		amount = amount - overkill;
	elseif ( event == "DAMAGE_SHIELD_MISSED" ) then
		-- Spell standard, Miss type
		spellId, spellName, spellSchool, missType = ...;

		-- Result String
		--resultStr = self.db.profile.format["DAMAGE_SHIELD_MISSED_"..missType];
		resultStr = self:DamageResult( resisted, blocked, absorbed, critical, glancing, crushing, overhealing, overkill );

		-- Disable appropriate sections
		valueEnabled = false;
		if ( not resultStr ) then
			resultEnabled = false;
		end
	elseif ( event == "PARTY_KILL" ) then	-- Unique Events
		-- Disable appropriate sections
		resultEnabled = false;
		valueEnabled = false;
		spellEnabled = false;
	elseif ( event == "ENCHANT_APPLIED" ) then	
		-- Get the enchant name, item id and item name
		spellName, itemId, itemName = ...;
		nameIsNotSpell = true;

		-- Disable appropriate sections
		valueIsItem = true;
		itemEnabled = true;
		resultEnabled = false;
	elseif ( event == "ENCHANT_REMOVED" ) then
		-- Get the enchant name, item id and item name
		spellName, itemId, itemName = ...;
		nameIsNotSpell = true;

		-- Disable appropriate sections
		valueIsItem = true;
		itemEnabled = true;
		resultEnabled = false;
		sourceEnabled = false;
		
	elseif ( event == "UNIT_DIED" or event == "UNIT_DESTROYED" ) then
		-- Swap Source with Dest
		sourceName = destName;
		sourceGUID = destGUID;
		sourceFlags = destFlags;

		-- Disable appropriate sections
		resultEnabled = false;
		sourceEnabled = true;
		destEnabled = false;
		spellEnabled = false;
		valueEnabled = false;
	elseif ( event == "ENVIRONMENTAL_DAMAGE" ) then
		--Environemental Type, Damage standard
			environmentalType, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = ...;

		-- Miss Event
		spellName = self.db.profile.format["ENVIRONMENTAL_DAMAGE_"..environmentalType];
		spellSchool = school;
		nameIsNotSpell = true;

		-- Parse the result string
		resultStr = self:DamageResult( resisted, blocked, absorbed, critical, glancing, crushing, overhealing, textMode, spellId, overkill );

		if ( not resultStr ) then
			resultEnabled = false;
		end
		
		amount = amount - overkill;
	elseif ( event == "DAMAGE_SPLIT" ) then
		-- Spell Standard Arguments, Damage standard
		spellId, spellName, spellSchool, amount, overkill, spellSchool, resisted, blocked, absorbed, critical, glancing, crushing = ...;

		-- Parse the result string
		resultStr = self:DamageResult( resisted, blocked, absorbed, critical, glancing, crushing, overhealing, overkill );

		if ( not resultStr ) then
			resultEnabled = false
		end
		
		amount = amount - overkill;
	end
	
	
	-- Actor name construction.
	--
	local sourceNameStr = "";
	local destNameStr = "";
	local sourceIcon = "";
	local destIcon = "";
	local spellNameStr = spellName;
	local extraSpellNameStr = extraSpellName;
	local itemNameStr = itemName;
	local actionEvent = ""..event;
	local actionStr = self.db.profile.format[actionEvent];
	local timestampStr = timestamp;

	-- If this ever succeeds, the event string is missing. 
	--
	if ( not actionStr ) then 
		actionStr = event;
	end

	-- Initialize the strings now
	sourceNameStr, destNameStr = sourceName, destName;
	
	-- Replace source and destination string with "You"
	if ( sourceName and CombatLog_Object_IsA(sourceFlags, COMBATLOG_FILTER_MINE) ) then
			sourceNameStr = UNIT_YOU;
	end
	if ( destName and CombatLog_Object_IsA(destFlags, COMBATLOG_FILTER_MINE) ) then
			destNameStr = UNIT_YOU;
	end
	
	-- Get the source color
	if ( sourceName ) then
		sourceColor	= self:ColorStringByUnitType( sourceFlags );
	end

	-- Get the dest color
	if ( destName ) then
		destColor	= self:ColorStringByUnitType( destFlags );
	end
	
	-- Only replace if there's an amount
	if ( amount ) then
		local amountColor;

		-- Color amount numbers
		if ( self.db.profile.amountColoring ) then
			-- To make white swings white
			if ( self.db.profile.noMeleeSwingColoring and spellSchool == SCHOOL_MASK_PHYSICAL and not spellId )  then
				-- Do nothing
			elseif ( self.db.profile.amountSchoolColoring ) then
				amountColor = self:ColorArrayBySchool(spellSchool);
			else
				amountColor = {
						["a"] = 1,
						["r"] = 1,
						["g"] = 1,
						["b"] = 1
					}
			end

		end
		if ( amountColor ) then
			amountColor = self:Color_FloatToText(amountColor);
			amount = format("|c%s%s|r", amountColor, amount);
		end

	end

	-- Power Type
	if ( powerType ) then
		powerTypeString =  CombatLog_String_PowerType(powerType);
	end
	
	-- Color source names
	if ( self.db.profile.unitColoring ) then 
		if ( sourceName and self.db.profile.sourceColoring ) then
			sourceNameStr = format("|c%s%s|r", sourceColor, sourceNameStr);
		end
		if ( destName and self.db.profile.destColoring ) then
			destNameStr = format("|c%s%s|r", destColor, destNameStr);
		end
	end

	-- If there's an action (always)
	if ( actionStr ) then
		local actionColor = nil;
		-- Color ability names
		if ( self.db.profile.actionColoring ) then

			if ( self.db.profile.actionSchoolColoring and spellSchool ) then
				actionColor = self:ColorArrayBySchool( spellSchool );
			else
				actionColor = {
					["a"] = 1,
					["r"] = 1,
					["g"] = 1,
					["b"] = 1
				}
			end
		-- Special option to only color "Miss" if there's no damage
		elseif ( self.db.profile.missColoring ) then

			if ( event ~= "SWING_DAMAGE" and
				event ~= "RANGE_DAMAGE" and
				event ~= "SPELL_DAMAGE" and
				event ~= "SPELL_PERIODIC_DAMAGE" ) then

				local actionColor = nil;

				if ( self.db.profile.actionSchoolColoring ) then
					actionColor = self:ColorArrayBySchool( spellSchool );
				else
					actionColor = {
						["a"] = 1,
						["r"] = 1,
						["g"] = 1,
						["b"] = 1
					}
				end

			end
		end
		
		if ( self.db.profile.actionAuraEventColoring  and not ( string.find(event, "_DISPEL") ) ) then
			local auraColor = self:ColorArrayByEventType( event, spellSchool )
			if (auraColor) then
				actionColor = auraColor
			end
		end

		if ( actionColor and actionStr ~= "" ) then
			actionColor = self:Color_FloatToText(actionColor);
			actionStr = format("|c%s%s|r", actionColor, actionStr);
		end
		
	end
	-- If there's a spell name
	if ( spellName ) then
		local abilityColor = nil;
		-- Color ability names
		if ( self.db.profile.abilityColoring ) then
			if ( self.db.profile.abilitySchoolColoring ) then
				abilityColor = self:ColorArrayBySchool( spellSchool );
			else
				abilityColor = {
					["a"] = 1,
					["r"] = 1,
					["g"] = 1,
					["b"] = 1
				}
			end
		end
		
		if ( self.db.profile.auraEventColoring and not ( string.find(event, "_DISPEL") ) ) then
			local auraColor = self:ColorArrayByEventType( event )
			if (auraColor) then
				abilityColor = auraColor
			end
		end

		if ( abilityColor ) then
			abilityColor = self:Color_FloatToText(abilityColor);
			spellNameStr = format("|c%s%s|r", abilityColor, spellName);
		end
	end

	-- If there's a extra spell name
	if ( extraSpellName ) then
		local abilityColor = nil;
		-- Color ability names
		if ( self.db.profile.abilityColoring ) then

			if ( self.db.profile.abilitySchoolColoring ) then
				abilityColor = self:ColorArrayBySchool( extraSpellSchool );
			else
				abilityColor = {
						["a"] = 1,
						["r"] = 1,
						["g"] = 1,
						["b"] = 1
					}
			end
		end
		
		if ( self.db.profile.auraEventColoring and ( string.find(event, "_DISPEL") ) ) then
			local auraColor = self:ColorArrayByEventType( event )
			if ( auraColor ) then
				abilityColor = auraColor
			end
		end
		
		if ( abilityColor ) then
			abilityColor = self:Color_FloatToText(abilityColor);
			extraSpellNameStr = format("|c%s%s|r", abilityColor, extraSpellName);
		end
	end

	-- Build Unit braces
	if ( self.db.profile.unitBraces ) then
		if ( sourceName and self.db.profile.sourceBraces ) then
			sourceNameStr = format(self.db.profile.format.STRING_BRACE_UNIT, braceColor, sourceNameStr, braceColor);
		end

		if ( destName and self.db.profile.destBraces ) then
			destNameStr = format(self.db.profile.format.STRING_BRACE_UNIT, braceColor, destNameStr, braceColor);
		end
	end

	-- Spell name braces
	if ( spellName and self.db.profile.spellBraces ) then 
		spellNameStr = format(self.db.profile.format.STRING_BRACE_SPELL, braceColor, spellNameStr, braceColor);
	end
	if ( extraSpellName and self.db.profile.spellBraces ) then 
		extraSpellNameStr = format(self.db.profile.format.STRING_BRACE_SPELL, braceColor, extraSpellNameStr, braceColor);
	end

	-- Build item braces
	if ( itemName and self.db.profile.itemBraces ) then
		itemNameStr = format(self.db.profile.format.STRING_BRACE_ITEM, braceColor, itemNameStr, braceColor);
	end

	local sourceString = "";
	local spellString = "";
	local actionString = "";
	local destString = "";
	local valueString = "";
	local resultString = "";

	--if ( sourceEnabled and sourceName and falseSource ) then
	if ( sourceEnabled and sourceName ) then
		sourceString = sourceNameStr;
	end

	if ( spellName ) then
		spellString = spellNameStr
	end

	if ( actionString ) then
		actionString = actionStr
	end

	if ( destEnabled and destName ) then
		destString = destNameStr
	end

	if ( valueEnabled ) then
		if ( critical ) then
			amount = format("%s%s%s", "*", amount, "*")
		end
		if ( strfind(originalEvent, "_PERIODIC") ) then
			amount = format("%s%s%s", "~", amount, "~")
		end
		if ( extraSpellEnabled and extraSpellNameStr ) then
			valueString = extraSpellNameStr;
		elseif ( valueIsItem and itemNameStr ) then
			valueString = itemNameStr
		elseif ( amount ) then
			if ( valueTypeEnabled ) then
				if ( valueType == 1 and schoolString ) then 
					valueString = format(self.db.profile.format.STRING_VALUE_SCHOOL, amount, schoolString);
				elseif ( valueType == 2 and powerTypeString ) then
					valueString = format(self.db.profile.format.STRING_VALUE_TYPE, amount, powerTypeString);
				end
			end
			if ( valueString == "" ) then
				valueString = amount;
			end
		end
	end

	if ( resultEnabled and resultStr ) then
		resultString = resultStr;
	end

	if ( not schoolString ) then
		schoolString = "";
	end
	if ( not powerTypeString ) then
		powerTypeString = "";
	end
	if ( not amount ) then
		amount = "";
	end
	
	local output
	local SwapStart, SwapStop = strfind(originalEvent, "AURA")
	if ( not SwapStart and not SwapStop ) then
		SwapStart, SwapStop = strfind(originalEvent, "ENCHANT")
	end
	if ( SwapStart and SwapStop ) then -- swap "actionString" with "spellString" to make Aura events look like "-- Arcane Intellect" instead of "Arcane Intellect --"
		local Swap = strsub(originalEvent, SwapStart, SwapStop)
		if ( Swap ) then
			output = format(formatString, sourceString, actionString, spellString, destString, valueString, resultString, schoolString, powerTypeString, amount, extraAmount);
		end
	else
		output = format(formatString, sourceString, spellString, actionString, destString, valueString, resultString, schoolString, powerTypeString, amount, extraAmount);
	end
	
	output = gsub(output, " [ ]+", " " ); -- extra white spaces
	output = gsub(output, " ([.,])", "%1" ); -- spaces before periods or comma
	output = gsub(output, "^([ .,]+)", "" ); -- spaces, period or comma at the beginning of a line
	
	
	output = self:AddTimestamp(output, timestamp)
	
	self.db.profile.output = output
	
	-- Debug line
	if ( YCL_DEBUG ) then
		ChatFrame3:AddMessage(event)
	end
	return output

end

--Add message to chatframe
function YurrCombatLog:AddOutput(output)

	local r, g, b, a = 1, 1, 1, 0
	outputFrame:AddMessage(output, r, g, b, nil, true)

end

--Experience
function YurrCombatLog:CHAT_MSG_COMBAT_XP_GAIN(event, fullexp)

	local start, stop, amount, source, totalbonus, bonus, bonustype, group, output
	local experienceEvent = self.db.profile.misc.experience
	local COMBATLOG_XPGAIN_FIRSTPERSON_UNNAMED = COMBATLOG_XPGAIN_FIRSTPERSON_UNNAMED
	local COMBATLOG_XPGAIN_FIRSTPERSON = COMBATLOG_XPGAIN_FIRSTPERSON
	local COMBATLOG_XPGAIN_EXHAUSTION1 = COMBATLOG_XPGAIN_EXHAUSTION1
	local COMBATLOG_XPGAIN_FIRSTPERSON_GROUP = COMBATLOG_XPGAIN_FIRSTPERSON_GROUP
	local COMBATLOG_XPGAIN_EXHAUSTION1_GROUP = COMBATLOG_XPGAIN_EXHAUSTION1_GROUP
	
	if( experienceEvent == true ) then
		-- Quest
		-- You gain %d experience.
		experience = string.gsub(COMBATLOG_XPGAIN_FIRSTPERSON_UNNAMED, "(%%d)", "(.+)")
		start, stop, amount = string.find(fullexp, experience)
		if (amount) then
			output = L["Exp: "]..amount
		end
		
		-- Solo
		-- %s dies, you gain %d experience.
		experience = string.gsub(string.gsub(COMBATLOG_XPGAIN_FIRSTPERSON, "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, source, amount = string.find(fullexp, experience)
		if (amount) then
			if (source) then
				output = L["Exp: "]..amount.."("..source..")"
			end
		end
		
		-- Solo rested
		-- %s dies, you gain %d experience. (%s exp %s bonus)
		experience = string.gsub(string.gsub(string.gsub(string.gsub(COMBATLOG_XPGAIN_EXHAUSTION1, "(%%s)", "(.+)"), "(%%d)", "(.+)"), "(%%s)", "(.+)"), "(%%s)", "(.+)");
		start, stop, source, amount, totalbonus, bonus, bonustype = string.find(fullexp, experience);
		if (amount) then
			if (source) then
				if (bonus) then
					bonus = string.sub(bonus, string.find(bonus, "+%d+", start))
					output = L["Exp: "]..amount.."("..source..")("..bonustype..bonus..")"
				end
			end
		end
		
		-- Grouped
		-- %s dies, you gain %d experience. (+%d group bonus)
		experience = string.gsub(string.gsub(string.gsub(COMBATLOG_XPGAIN_FIRSTPERSON_GROUP, "(%%s)", "(.+)"), "(%%d)", "(.+)"), "(%%d)", "(.+)")
		start, stop, source, amount, group = string.find(fullexp, experience)
		if (amount) then
			if (source) then
				if (group) then
					group = string.sub(group, string.find(group, "%d+", start))
					output = L["Exp: "]..amount.."("..source..")("..L["G+"]..group..")"
				end
			end
		end
		
		-- Grouped rested
		-- %s dies, you gain %d experience. (%s exp %s bonus, +%d group bonus)
		experience = string.gsub(string.gsub(string.gsub(string.gsub(COMBATLOG_XPGAIN_EXHAUSTION1_GROUP, "(%%s)", "(.+)"), "(%%d)", "(.+)"), "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, source, amount, totalbonus, bonus, bonustype, group = string.find(fullexp, experience)
		if (amount) then
			if (source) then
				if (bonus) then
					if (group) then
						bonus = string.sub(bonus, string.find(bonus, "+%d+", start))
						group = string.sub(group, string.find(group, "%d+", start))
						output = L["Exp: "]..amount.."("..source..")("..bonustype..bonus..")("..L["G+"]..group..")"
					end
				end
			end
		end
		output = self:AddTimestamp(output)
		outputFrame:AddMessage(output, nil)
	end

end

--Honor
function YurrCombatLog:CHAT_MSG_COMBAT_HONOR_GAIN(event, fullhonor)

	local honor, start, stop, amount, source, output, rank
	local honorEvent = self.db.profile.misc.honor
	local COMBATLOG_HONORAWARD = COMBATLOG_HONORAWARD
	local COMBATLOG_HONORGAIN = COMBATLOG_HONORGAIN

	if ( honorEvent == true ) then
		-- Honor
		-- You have been awarded %d honor points.
		honor = string.gsub(COMBATLOG_HONORAWARD, "(%%d)", "(.+)")
		start, stop, amount = string.find(fullhonor, honor)
		if (amount) then
		   output = L["Honor: "]..amount
		end
		
		-- HonorKill
		-- %s dies, honorable kill Rank: %s (%d Honor Points)
		honor = string.gsub(string.gsub(string.gsub(COMBATLOG_HONORGAIN, "(%%s)", "(.+)"), "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, source, rank, _, amount = string.find(fullhonor, honor)
		if (source) then
		   if (rank) then
		      if (amount) then
		         amount = string.sub(amount, string.find(amount, "%d+", start))
		         output = L["Honor: "]..amount.." ("..rank.." "..source..")"
		      end
		   end
		end
		output = self:AddTimestamp(output)
		outputFrame:AddMessage(output, nil)
	end

end

--Reputation
function YurrCombatLog:CHAT_MSG_COMBAT_FACTION_CHANGE(event, fullrep)

	local gain, start, stop, faction, amount, output
	local factionEvent = self.db.profile.misc.faction
	local FACTION_STANDING_INCREASED = FACTION_STANDING_INCREASED
	local FACTION_STANDING_DECREASED = FACTION_STANDING_DECREASED

	if( factionEvent == true ) then
		-- Reputation with %s increased by %d.
		gain = string.gsub(string.gsub(FACTION_STANDING_INCREASED, "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, faction, amount = string.find(fullrep, gain)
		if (faction) then
			if (amount) then
				output = L["Rep: "]..faction.." +"..amount
			end
		end
		
		-- Reputation with %s decreased by %d.
		gain = string.gsub(string.gsub(FACTION_STANDING_DECREASED, "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, faction, amount = string.find(fullrep, gain)
		if (faction) then
			if (amount) then
				output = L["Rep: "]..faction.." -"..amount
				gain, faction, amount = nil, nil, nil
			end
		end
		output = self:AddTimestamp(output)
		outputFrame:AddMessage(output, nil)
	end

end

--Skillups
function YurrCombatLog:CHAT_MSG_SKILL(event, fullSkillup)

	local start, stop, skill, amount, skillup, output
	local skillEvent = self.db.profile.misc.skill
	local ERR_SKILL_UP_SI = ERR_SKILL_UP_SI

	if ( skillEvent == true ) then
		-- Skillup
		-- Your skill in %s has increased to %d.
		skillup = string.gsub(string.gsub(ERR_SKILL_UP_SI, "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, skill, amount = string.find(fullSkillup, skillup)
		if (skill) then
			if (amount) then
				output = L["Skill: "]..skill.."("..amount..")"
				output = self:AddTimestamp(output)
				outputFrame:AddMessage(output, nil)
			end
		end
	end

end

--Combat
function YurrCombatLog:PLAYER_REGEN_ENABLED()

	local output
	local combat = self.db.profile.misc.combat
	
	if combat == true then
		output = " -- "..COMBAT
		output = self:AddTimestamp(output)
		outputFrame:AddMessage(output, nil)
	end

end
function YurrCombatLog:PLAYER_REGEN_DISABLED()

	local output
	local combat = self.db.profile.misc.combat
	
	if combat == true then
		output = " ++ "..COMBAT
		output = self:AddTimestamp(output)
		outputFrame:AddMessage(output, nil)
	end

end

function YurrCombatLog:AddTimestamp(output, timestamp)
	local enabled = self.db.profile.timestamp
	local fmt = self.db.profile.timestampFormat
	local colors = self.db.profile.otherColors
	local timestampColor
	
	if ( enabled ) then
		timestampColor = self:Color_FloatToText(colors.timestampColor.r, colors.timestampColor.g, colors.timestampColor.b)
		timestamp = "|c"..timestampColor..date(fmt, timestamp).."|r"
		if output then
			output = format("%s%s", timestamp, output)
		end
	end
	
	return output
end

function YurrCombatLog:getColor(info)
	if info[#info-1] == "unitColors" then
		info[#info] = tonumber(info[#info])
	end
	return self.db.profile[info[#info-1]][info[#info]].r, self.db.profile[info[#info-1]][info[#info]].g, self.db.profile[info[#info-1]][info[#info]].b
end
function YurrCombatLog:setColor(info, r, g, b)
	self.db.profile[info[#info-1]][info[#info]] = { ["r"]=r, ["g"]=g, ["b"]=b }
end

function YurrCombatLog:getEvent(info)
	info[#info-2] = tonumber(info[#info-2])
	return self.db.profile.filters[info[#info-2]].filters[1].eventList[info[#info]]
end
function YurrCombatLog:setEvent(info, value)
	info[#info-2] = tonumber(info[#info-2])
	self.db.profile.filters[info[#info-2]].filters[1].eventList[info[#info]] = value
end

function YurrCombatLog:addFilter(info, value)

	tinsert(self.db.profile.filters, 
		{
			-- Descriptive Information
			name = value,

			-- The actual client filters
			filters = {
				[1] = {
					eventList = {
						  ["ENVIRONMENTAL_DAMAGE"] = true,
						  ["SWING_DAMAGE"] = true,
						  ["SWING_MISSED"] = true,
						  ["RANGE_DAMAGE"] = true,
						  ["RANGE_MISSED"] = true,
						  --["SPELL_CAST_START"] = true,
						  --["SPELL_CAST_SUCCESS"] = true,
						  --["SPELL_CAST_FAILED"] = true,
						  ["SPELL_MISSED"] = true,
						  ["SPELL_DAMAGE"] = true,
						  ["SPELL_HEAL"] = true,
						  ["SPELL_ENERGIZE"] = true,
						  ["SPELL_DRAIN"] = true,
						  ["SPELL_LEECH"] = true,
						  ["SPELL_INSTAKILL"] = true,
						  ["SPELL_INTERRUPT"] = true,
						  ["SPELL_EXTRA_ATTACKS"] = true,
						  --["SPELL_DURABILITY_DAMAGE"] = true,
						  --["SPELL_DURABILITY_DAMAGE_ALL"] = true,
						  ["SPELL_AURA_APPLIED"] = true,
						  ["SPELL_AURA_APPLIED_DOSE"] = true,
						  ["SPELL_AURA_REMOVED"] = true,
						  ["SPELL_AURA_REMOVED_DOSE"] = true,
						  ["SPELL_AURA_BROKEN"] = true,
						  ["SPELL_AURA_BROKEN_SPELL"] = true,
						  ["SPELL_AURA_REFRESH"] = true,
						  ["SPELL_DISPEL"] = true,
						  ["SPELL_STOLEN"] = true,
						  ["ENCHANT_APPLIED"] = true,
						  ["ENCHANT_REMOVED"] = true,
						  ["SPELL_PERIODIC_MISSED"] = true,
						  ["SPELL_PERIODIC_DAMAGE"] = true,
						  ["SPELL_PERIODIC_HEAL"] = true,
						  ["SPELL_PERIODIC_ENERGIZE"] = true,
						  ["SPELL_PERIODIC_DRAIN"] = true,
						  ["SPELL_PERIODIC_LEECH"] = true,
						  ["SPELL_DISPEL_FAILED"] = true,
						  ["DAMAGE_SHIELD"] = true,
						  ["DAMAGE_SHIELD_MISSED"] = true,
						  --["DAMAGE_SPLIT"] = true,
						  ["PARTY_KILL"] = true,
						  ["UNIT_DIED"] = true,
						  ["UNIT_DESTROYED"] = true
					},
					sourceFlags = {
						[1297] = true,
						--[COMBATLOG_FILTER_MY_PET] = true
					},
					destFlags = nil,
					flagOptions = {
						[1] = true,
						[16] = true,
						[256] = true,
						[1024] = true,
					},
				},
				[2] = {
					eventList = {
						  --["ENVIRONMENTAL_DAMAGE"] = true,
						  ["SWING_DAMAGE"] = true,
						  ["SWING_MISSED"] = true,
						  ["RANGE_DAMAGE"] = true,
						  ["RANGE_MISSED"] = true,
						  --["SPELL_CAST_START"] = true,
						  --["SPELL_CAST_SUCCESS"] = true,
						  --["SPELL_CAST_FAILED"] = true,
						  ["SPELL_MISSED"] = true,
						  ["SPELL_DAMAGE"] = true,
						  ["SPELL_HEAL"] = true,
						  ["SPELL_ENERGIZE"] = true,
						  ["SPELL_DRAIN"] = true,
						  ["SPELL_LEECH"] = true,
						  ["SPELL_INSTAKILL"] = true,
						  ["SPELL_INTERRUPT"] = true,
						  ["SPELL_EXTRA_ATTACKS"] = true,
						  --["SPELL_DURABILITY_DAMAGE"] = true,
						  --["SPELL_DURABILITY_DAMAGE_ALL"] = true,
						  --["SPELL_AURA_APPLIED"] = true,
						  --["SPELL_AURA_APPLIED_DOSE"] = true,
						  --["SPELL_AURA_REMOVED"] = true,
						  --["SPELL_AURA_REMOVED_DOSE"] = true,
						  ["SPELL_DISPEL"] = true,
						  ["SPELL_STOLEN"] = true,
						  ["ENCHANT_APPLIED"] = true,
						  ["ENCHANT_REMOVED"] = true,
						  --["SPELL_PERIODIC_MISSED"] = true,
						  --["SPELL_PERIODIC_DAMAGE"] = true,
						  --["SPELL_PERIODIC_HEAL"] = true,
						  --["SPELL_PERIODIC_ENERGIZE"] = true,
						  --["SPELL_PERIODIC_DRAIN"] = true,
						  --["SPELL_PERIODIC_LEECH"] = true,
						  ["SPELL_DISPEL_FAILED"] = true,
						  --["DAMAGE_SHIELD"] = true,
						  --["DAMAGE_SHIELD_MISSED"] = true,
						  --["DAMAGE_SPLIT"] = true,
						  ["PARTY_KILL"] = true,
						  ["UNIT_DIED"] = true,
						  ["UNIT_DESTROYED"] = true,
					},
					sourceFlags = nil,
					destFlags = {
						[1297] = true,
						--[COMBATLOG_FILTER_MY_PET] = true,
					},
					flagOptions = {
						[1] = true,
						[16] = true,
						[256] = true,
						[1024] = true,
					},
				},
			},
		}
	)
	
	self:ParseFilters()

end

function YurrCombatLog:getMisc(info)
	return self.db.profile[info[#info-1]][info[#info]]
end
function YurrCombatLog:setMisc(info, value)
	self.db.profile[info[#info-1]][info[#info]] = value
end


function YurrCombatLog:getFlags(info)
	
	local value
	local filters = self.db.profile.filters
	info[#info-3] = tonumber(info[#info-3])
	info[#info] = tonumber(info[#info])
	
	
	if info[#info-2] == "sourceFlags" then
		return self.db.profile.filters[info[#info-3]].filters[1].flagOptions[info[#info]]
	elseif info[#info-2] == "destFlags" then
		return self.db.profile.filters[info[#info-3]].filters[2].flagOptions[info[#info]]
	end
	
end
function YurrCombatLog:setFlags(info, value)
	local filters = self.db.profile.filters
	info[#info-3] = tonumber(info[#info-3])
	info[#info] = tonumber(info[#info])
	
	if info[#info-2] == "sourceFlags" then
		self.db.profile.filters[info[#info-3]].filters[1].flagOptions[info[#info]] = value
		local sourceFlags = 0
		for k, v in pairs (filters[info[#info-3]].filters[1].flagOptions) do
			if v == true then
				sourceFlags = bit_bor(sourceFlags, k)
			end
		end
		self.db.profile.filters[info[#info-3]].filters[1].sourceFlags = {}
		self.db.profile.filters[info[#info-3]].filters[1].sourceFlags[sourceFlags] = true
	elseif info[#info-2] == "destFlags" then
		self.db.profile.filters[info[#info-3]].filters[2].flagOptions[info[#info]] = value
		local destFlags = 0
		for k, v in pairs (filters[info[#info-3]].filters[2].flagOptions) do
			if v == true then
				destFlags = bit_bor(destFlags, k)
			end
		end
		self.db.profile.filters[info[#info-3]].filters[2].destFlags = {}
		self.db.profile.filters[info[#info-3]].filters[2].destFlags[destFlags] = true
	end
end

function YurrCombatLog:applyFilter(info, value)
	local config = self.db.profile.filters
	
	if ( not config ) then
		return;
	end
	
	if info then
		local sourceFlags2 = 0
		info[#info-1] = tonumber(info[#info-1])
		for k3, v3 in pairs (config[info[#info-1]].filters[1].flagOptions) do
			if v3 == true then
				sourceFlags2 = bit_bor(sourceFlags2, k3)
			end
		end
		local destFlags2 = 0
		for k4, v4 in pairs (config[info[#info-1]].filters[2].flagOptions) do
			if v4 == true then
				destFlags2 = bit_bor(destFlags2, k4)
			end
		end
		self.db.profile.filters[info[#info-1]].filters[1].sourceFlags[sourceFlags2] = value
		self.db.profile.filters[info[#info-1]].filters[2].destFlags[destFlags2] = value
	end
	
	CombatLogResetFilter()
	
	for k in pairs (config) do
		-- Loop over all associated filters
		local eventList;
		for k1,v1 in pairs(config[k].filters) do
			local eList
			-- Only use the first filter's eventList
			eventList = config[k].filters[1].eventList;
			if ( eventList ) then
				for k2,v2 in pairs(eventList) do 
					if ( v2 == true ) then
						eList = eList and (eList .. ", " .. k2) or k2
					end
				end
			end
			
			local sourceFlags, destFlags;
			if ( v1.sourceFlags ) then
				sourceFlags = 0;
				for k2, v2 in pairs(v1.sourceFlags) do
					-- Support for GUIDs
					if ( type (k2) == "string" ) then
						sourceFlags = k2;
						break;
					end
					-- Otherwise OR bits
					if ( v2 ) then
						sourceFlags = bit_bor(sourceFlags, k2);
					end
				end
			end
			if ( v1.destFlags ) then
				destFlags = 0;
				for k2, v2 in pairs(v1.destFlags) do
					-- Support for GUIDs
					if ( type (k2) == "string" ) then
						destFlags = k2;
						break;
					end
					-- Otherwise OR bits
					if ( v2 ) then
						destFlags = bit_bor(destFlags, k2);
					end
				end
			end
			if ( type(sourceFlags) == "string" and destFlags == 0 ) then
				destFlags = nil;
			end
			if ( type(destFlags) == "string" and sourceFlags == 0 ) then
				sourceFlags = nil;
			end

			-- This is a HACK!!!  Need filters to be able to accept empty or zero sourceFlags or destFlags
			if ( sourceFlags == 0 or destFlags == 0 ) then
				CombatLogAddFilter("", COMBATLOG_FILTER_MINE, nil);
			else
				CombatLogAddFilter(eList, sourceFlags, destFlags);
			end
		end
	end
	self:Refilter()
end
function YurrCombatLog:getFilter(info)
	local config = self.db.profile.filters
	info[#info-1] = tonumber(info[#info-1])
	
	local sourceFlags2 = 0
	for k3, v3 in pairs (config[info[#info-1]].filters[1].flagOptions) do
		if v3 == true then
			sourceFlags2 = bit_bor(sourceFlags2, k3)
		end
	end
	local destFlags2 = 0
	for k4, v4 in pairs (config[info[#info-1]].filters[2].flagOptions) do
		if v4 == true then
			destFlags2 = bit_bor(destFlags2, k4)
		end
	end
	if self.db.profile.filters[info[#info-1]].filters[1].sourceFlags[sourceFlags2] == true and self.db.profile.filters[info[#info-1]].filters[2].destFlags[destFlags2] == true then
		return true
	else
		return false
	end
end


-- Copyright 2008 Copystring"